# GridLayoutBase

![CI](https://github.com/jkrumbiegel/GridLayoutBase.jl/workflows/CI/badge.svg)
[![Codecov](https://codecov.io/gh/jkrumbiegel/GridLayoutBase.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/jkrumbiegel/GridLayoutBase.jl)

const Optional{T} = Union{Nothing, T}

struct RectSides{T}
    left::T
    right::T
    bottom::T
    top::T
end

abstract type Side end

struct Left <: Side end
struct Right <: Side end
struct Top <: Side end
struct Bottom <: Side end
# for protrusion content:
struct TopLeft <: Side end
struct TopRight <: Side end
struct BottomLeft <: Side end
struct BottomRight <: Side end

struct Inner <: Side end
struct Outer <: Side end

abstract type GridDir end
struct Col <: GridDir end
struct Row <: GridDir end

struct RowCols{T <: Union{Number, Vector{Float32}}}
    lefts::T
    rights::T
    tops::T
    bottoms::T
end


"""
    struct Span

Used to specify space that is occupied in a grid. Like 1:1|1:1 for the first square,
or 2:3|1:4 for a rect over the 2nd and 3rd row and the first four columns.
"""
struct Span
    rows::UnitRange{Int64}
    cols::UnitRange{Int64}
end

"""
    mutable struct GridContent{G}

Wraps content elements of a `GridLayout`. It keeps track of the `parent`, the `content` and its position in the grid via `span` and `side`.
"""
mutable struct GridContent{G} # G should be GridLayout but can't be used before definition
    parent::Optional{G}
    content # accessing the content object which can be anything is rare, so avoid overspecialization (type hiding)
    span::Span
    side::Side
    protrusions_handle::Optional{Function}
    reportedsize_handle::Optional{Function}
end

"""
AlignMode that excludes the protrusions from the bounding box. Construct with
`Inside()`.

See also `Outside` and `Mixed`.
"""
struct Inside end

"""
AlignMode that includes the protrusions within the bounding box, plus paddings.

See also `Inside` and `Mixed`.
"""
struct Outside
    padding::RectSides{Float32}
end

"""
    Outside()

Construct an `Outside` AlignMode with no padding.
"""
Outside() = Outside(0f0)
"""
    Outside(padding::Real)

Construct an `Outside` AlignMode with equal padding on all sides.
"""
Outside(padding::Real) = Outside(RectSides{Float32}(padding, padding, padding, padding))
"""
    Outside(left::Real, right::Real, bottom::Real, top::Real)

Construct an `Outside` AlignMode with different paddings on each side.
"""
Outside(left::Real, right::Real, bottom::Real, top::Real) =
    Outside(RectSides{Float32}(left, right, bottom, top))

"""
    Protrusion(p::Float32)

Can be used within a `Mixed` alignmode to override a protrusion manually.
"""
struct Protrusion
    p::Float32
end

"""
AlignMode that is `Inside` where `padding` is `Nothing`, `Outside` where it is
`Real`, and overrides the protrusion with a fixed value where it is a
`Protrusion`.

See also `Inside` and `Outside`.
"""
struct Mixed
    sides::RectSides{Union{Nothing, Float32, Protrusion}}
end

"""
    Mixed(; left = nothing, right = nothing, bottom = nothing, top = nothing)

Construct a `Mixed` AlignMode, which has different behavior on each side.
Arguments that are `nothing` will exclude protrusions from the bounding box on
that side. Those that are real numbers will be padded by that amount and
include protrusions from the bounding box on that side. Arguments that are
`Protrusion` will override the protrusion with a fixed value.
"""
function Mixed(; left = nothing, right = nothing, bottom = nothing, top = nothing)
    sides = map((left, right, bottom, top)) do side
        (side === nothing || side isa Protrusion) ? side : Float32(side)
    end
    Mixed(RectSides{Union{Nothing, Float32, Protrusion}}(sides...))
end

const AlignMode = Union{Inside, Outside, Mixed}


"""
    struct Auto

If used as a `GridLayout`'s row / column size and `trydetermine == true`, signals to the `GridLayout` that the row / column should shrink to match the largest determinable element inside.
If no size of a content element can be determined, the remaining space is split between all `Auto` rows / columns according to their `ratio`.

If used as width / height of a layoutable element and `trydetermine == true`, the element's computed width / height will report the auto width / height if it can be determined.
This enables a parent `GridLayout` to adjust its column / rowsize to the element's width / height.
If `trydetermine == false`, the element's computed width / height will report `nothing` even if an auto width / height can be determined, which will prohibit a parent `GridLayout` from adjusting a row / column to the element's width / height.
This is useful to, e.g., prohibit a `GridLayout` from shrinking a column's width to the width of a super title, even though the title's width can be auto-determined.

The `ratio` is ignored if `Auto` is used as an element size.
"""
struct Auto
    trydetermine::Bool # false for determinable size content that should be ignored
    ratio::Float32 # float ratio in case it's not determinable

    Auto(trydetermine::Bool = true, ratio::Real = 1.0) = new(trydetermine, ratio)
end
Auto(ratio::Real) = Auto(true, ratio)

struct Fixed
    x::Float32
end
struct Relative
    x::Float32
end
struct Aspect
    index::Int
    ratio::Float32
end

const ContentSize = Union{Auto, Fixed, Relative, Aspect}
const GapSize = Union{Fixed, Relative}

struct Dimensions
    inner::Tuple{Optional{Float32}, Optional{Float32}}
    outer::RectSides{Float32}
end

"""
    struct LayoutObservables{G}

`T` is the same type parameter of contained `GridContent`, `G` is `GridLayout` which is defined only after `LayoutObservables`.

A collection of `Observable`s and an optional `GridContent` that are needed to interface with the MakieLayout layouting system.

- `suggestedbbox::Observable{Rect2f}`: The bounding box that an element should place itself in. Depending on the element's `width` and `height` attributes, this is not necessarily equal to the computedbbox.
- `protrusions::Observable{RectSides{Float32}}`: The sizes of content "sticking out" of the main element into the `GridLayout` gaps.
- `reporteddimensions::Observable{Dimensions}`: The dimensions (inner and outer) that the object communicates to the containing `GridLayout`.
- `autosize::Observable{NTuple{2, Optional{Float32}}}`: The width and height that the element reports to its parent `GridLayout`. If the element doesn't want to cause the parent to adjust to its size, autosize can hide the reportedsize from it by being set to `nothing`.
- `computedbbox::Observable{Rect2f}`: The bounding box that the element computes for itself after it has received a suggestedbbox.
- `gridcontent::Optional{GridContent{G}}`: A reference of a `GridContent` if the element is currently placed in a `GridLayout`. This can be used to retrieve the parent layout, remove the element from it or change its position, and assign it to a different layout.
"""
struct LayoutObservables{G} # G again GridLayout
    suggestedbbox::Observable{Rect2f}
    protrusions::Observable{RectSides{Float32}}
    reporteddimensions::Observable{Dimensions}
    autosize::Observable{NTuple{2, Optional{Float32}}}
    computedbbox::Observable{Rect2f}
    gridcontent::Base.RefValue{Optional{GridContent{G}}} # the connecting link to the gridlayout
    block_updates::Base.RefValue{Bool}
end

struct HorizontalAlignment
    x::Float32
end
struct VerticalAlignment
    x::Float32
end

const SizeAttribute = Union{Nothing, Float32, Fixed, Relative, Auto}

mutable struct GridLayout
    parent # this parent is supposed to be any kind of object where it's beneficial
    # to access it through the assigned GridLayout, like a Figure in Makie
    content::Vector{GridContent{GridLayout}}
    size::Tuple{Int, Int}
    offsets::Tuple{Int, Int}
    rowsizes::Vector{ContentSize}
    colsizes::Vector{ContentSize}
    addedrowgaps::Vector{GapSize}
    addedcolgaps::Vector{GapSize}
    alignmode::Observable{AlignMode}
    equalprotrusiongaps::Tuple{Bool, Bool}
    block_updates::Bool
    layoutobservables::LayoutObservables{GridLayout}
    width::Observable{SizeAttribute}
    height::Observable{SizeAttribute}
    tellwidth::Observable{Bool}
    tellheight::Observable{Bool}
    halign::Observable{HorizontalAlignment}
    valign::Observable{VerticalAlignment}
    default_rowgap::GapSize
    default_colgap::GapSize

    function GridLayout(
        parent,
        content, size, offsets, rowsizes, colsizes,
        addedrowgaps, addedcolgaps, alignmode, equalprotrusiongaps,
        layoutobservables, width, height, tellwidth, tellheight, halign, valign, default_rowgap, default_colgap)

        gl = new(parent, content, size, offsets, rowsizes, colsizes,
            addedrowgaps, addedcolgaps, alignmode, equalprotrusiongaps,
            false, layoutobservables, width, height, tellwidth, tellheight,
            halign, valign, default_rowgap, default_colgap)

        validategridlayout(gl)

        gl
    end
end

const Indexables = Union{UnitRange, Int, Colon}
const AutoSize = Union{Nothing, Float32}

struct GridPosition
    layout::GridLayout
    span::Span
    side::Side
end

struct GridSubposition
    parent::Union{GridPosition, GridSubposition}
    rows
    cols
    side::Side
end

using Documenter, GridLayoutBase

makedocs(;
    modules=[GridLayoutBase],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
    ],
    repo="https://github.com/jkrumbiegel/GridLayoutBase.jl/blob/{commit}{path}#L{line}",
    sitename="GridLayoutBase.jl",
    authors="Julius Krumbiegel",
    assets=String[],
)

deploydocs(;
    repo="github.com/jkrumbiegel/GridLayoutBase.jl",
)

mutable struct DebugRect
    layoutobservables::GridLayoutBase.LayoutObservables{GridLayout}
    width::Observable
    height::Observable
    tellwidth::Observable
    tellheight::Observable
    halign::Observable
    valign::Observable
    leftprot::Observable
    rightprot::Observable
    bottomprot::Observable
    topprot::Observable
    alignmode::Observable
end


observablify(x::Observable) = x
observablify(x, type=Any) = Observable{type}(x)

function DebugRect(; bbox = nothing, width=nothing, height=nothing,
    tellwidth = true, tellheight = true, halign=:center,
    valign=:center, topprot=0.0, leftprot=0.0, rightprot=0.0, bottomprot=0.0,
    alignmode = Inside())

    width = observablify(width)
    height = observablify(height)
    tellwidth = observablify(tellwidth)
    tellheight = observablify(tellheight)
    halign = observablify(halign)
    valign = observablify(valign)
    topprot = observablify(topprot, Float32)
    leftprot = observablify(leftprot, Float32)
    rightprot = observablify(rightprot, Float32)
    bottomprot = observablify(bottomprot, Float32)
    alignmode = observablify(alignmode)

    protrusions::Observable{GridLayoutBase.RectSides{Float32}} = map(leftprot, rightprot, bottomprot, topprot) do l, r, b, t
        GridLayoutBase.RectSides{Float32}(l, r, b, t)
    end

    layoutobservables = GridLayoutBase.LayoutObservables(width,
        height, tellwidth, tellheight, halign, valign, alignmode;
        suggestedbbox = bbox, protrusions = protrusions)

    DebugRect(layoutobservables, height, width, tellwidth, tellheight,
        halign, valign, leftprot, rightprot, bottomprot, topprot, alignmode)
end

Base.show(io::IO, dr::DebugRect) = print(io, "DebugRect()")

let
    while true
        ccall(:jl_generating_output, Cint, ()) == 1 || break
        gl = GridLayout()
        gl2 = GridLayout()
        gl[1, 1] = gl2
        determinedirsize(gl, GridLayoutBase.Row())
        compute_rowcols(gl, GridLayoutBase.suggestedbboxobservable(gl)[])
        update!(gl)
        align_to_bbox!(gl2, GridLayoutBase.suggestedbboxobservable(gl2)[])
        compute_rowcols(gl2, GridLayoutBase.suggestedbboxobservable(gl2)[])
        break
    end
    nothing
end

Base.eltype(::Type{RectSides{T}}) where T = T

"""
Shorthand for `isnothing(optional) ? fallback : optional`
"""
@inline ifnothing(optional, fallback) = isnothing(optional) ? fallback : optional

function Base.foreach(f::Function, contenttype::Type, layout::GridLayout; recursive = true)
    for c in layout.content
        if recursive && c.content isa GridLayout
            foreach(f, contenttype, c.content)
        elseif c.content isa contenttype
            f(c.content)
        end
    end
end

"""
Swaps or rotates the layout positions of the given elements to their neighbor's.
"""
function swap!(layout_elements...)
    gridcontents = gridcontent.(collect(layout_elements))

    # copy relevant fields before gridcontents are mutated
    parents = map(gc -> gc.parent, gridcontents)
    spans = map(gc -> gc.span, gridcontents)
    sides = map(gc -> gc.side, gridcontents)

    for (gc, parent, span, side) in zip(circshift(gridcontents, 1), parents, spans, sides)
        parent[span.rows, span.cols, side] = gc.content
    end
end

function zcumsum(v::AbstractVector{T}) where T
    vpad = [[zero(T)]; v]  # inference-friendly
    cumsum!(vpad, vpad)
end


"""
    grid!(content::Vararg{Pair}; kwargs...)

Creates a GridLayout with all pairs contained in `content`. Each pair consists
of an iterable with row and column spans, and a content object. Each content
object is then placed in the GridLayout at the span from its pair.

Example:

grid!(
    [1, 1] => obj1,
    [1, 2] => obj2,
    [2, :] => obj3,
)
"""
function grid!(content::Vararg{Pair}; kwargs...)
    g = GridLayout(; kwargs...)
    for ((rows, cols), element) in content
        g[rows, cols] = element
    end
    g
end

"""
    hbox!(content::Vararg; kwargs...)

Creates a single-row GridLayout with all elements contained in `content` placed
from left to right.
"""
function hbox!(content::Vararg; kwargs...)
    ncols = length(content)
    g = GridLayout(1, ncols; kwargs...)
    for (i, element) in enumerate(content)
        g[1, i] = element
    end
    g
end

"""
    vbox!(content::Vararg; kwargs...)

Creates a single-column GridLayout with all elements contained in `content` placed
from top to bottom.
"""
function vbox!(content::Vararg; kwargs...)
    nrows = length(content)
    g = GridLayout(nrows, 1; kwargs...)
    for (i, element) in enumerate(content)
        g[i, 1] = element
    end
    g
end



"""
    grid!(content::AbstractMatrix; kwargs...)

Creates a GridLayout filled with matrix-like content. The size of the grid will
be the size of the matrix.
"""
function grid!(content::AbstractMatrix; kwargs...)
    nrows, ncols = size(content)
    g = GridLayout(nrows, ncols; kwargs...)
    for i in 1:nrows, j in 1:ncols
        g[i, j] = content[i, j]
    end
    g
end


left(rect::Rect{2}) = minimum(rect)[1]
right(rect::Rect{2}) = maximum(rect)[1]
bottom(rect::Rect{2}) = minimum(rect)[2]
top(rect::Rect{2}) = maximum(rect)[2]

"""
    BBox(left::Number, right::Number, bottom::Number, top::Number)

Convenience constructor to create a `Rect2` with left, right, bottom and top
extent instead of the usual origin, widths combination.
"""
function BBox(left::T1, right::T2, bottom::T3, top::T4) where {T1 <: Real, T2 <: Real, T3 <: Real, T4 <: Real}
    T = promote_type(T1, T2, T3, T4, Float32) # Float32 to skip Int outputs
    return BBox(T, left, right, bottom, top)
end

function BBox(T::DataType, left::Real, right::Real, bottom::Real, top::Real)
    mini = (left, bottom)
    maxi = (right, top)
    return Rect2{T}(mini, maxi .- mini)
end

function RowCols(ncols::Integer, nrows::Integer)
    return RowCols(
        zeros(Float32, ncols),
        zeros(Float32, ncols),
        zeros(Float32, nrows),
        zeros(Float32, nrows)
    )
end

Base.getindex(rowcols::RowCols, ::Left) = rowcols.lefts
Base.getindex(rowcols::RowCols, ::Right) = rowcols.rights
Base.getindex(rowcols::RowCols, ::Top) = rowcols.tops
Base.getindex(rowcols::RowCols, ::Bottom) = rowcols.bottoms

"""
    eachside(f)
Calls f over all sides (Left, Right, Top, Bottom), and creates a BBox from the result of f(side)
"""
function eachside(f)
    return BBox(f(Left()), f(Right()), f(Bottom()), f(Top()))
end

"""
mapsides(
       f, first::Union{Rect{2}, RowCols}, rest::Union{Rect{2}, RowCols}...
   )::Rect2f
Maps f over all sides of the rectangle like arguments.
e.g.
```
mapsides(BBox(left, right, bottom, top)) do side::Side, side_val::Number
    return ...
end::Rect2f
```
"""
function mapsides(
        f, first::Union{Rect{2}, RowCols}, rest::Union{Rect{2}, RowCols}...
    )
    return eachside() do side
        f(side, getindex.((first, rest...), (side,))...)
    end
end

function set_nrows!(gl, x)
    gl.size = (x, gl.size[2])
end
function set_ncols!(gl, x)
    gl.size = (gl.size[1], x)
end

function set_rowoffset!(gl, x)
    gl.offsets = (x, offset(gl, Col()))
end
function set_coloffset!(gl, x)
    gl.offsets = (offset(gl, Row()), x)
end

offset(gl, ::Row) = offsets(gl)[1]
offset(gl, ::Col) = offsets(gl)[2]

# convert an index into an array from 1:nrow or 1:ncol
# into the respective column / row number that can also be negative if offset
offset(gl, i, ::Row) = i + offset(gl, Row())
offset(gl, i, ::Col) = i + offset(gl, Col())

# convert a column / row number that can also be negative if offset
# to an index from 1:nrow or 1:ncol
unoffset(gl, i, ::Row) = i - offset(gl, Row())
unoffset(gl, i, ::Col) = i - offset(gl, Col())

using GridLayoutBase
using GridLayoutBase: GridSubposition
using GridLayoutBase: offsets
using GridLayoutBase: RectSides
using Test
using Observables

include("debugrect.jl")

# run this to make bboxes easier to read: Base.show(io::IO, b::GridLayoutBase.GeometryBasics.Rect2) = print(io, "BBox($(left(b)), $(right(b)), $(bottom(b)), $(top(b)))")

@testset "GridLayout Zero Outside AlignMode" begin
    bbox = BBox(0, 1000, 0, 1000)
    layout = GridLayout(bbox = bbox, alignmode = Outside(0))
    dr = layout[1, 1] = DebugRect()

    @test computedbboxobservable(dr)[] == bbox

    dr.topprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 900)
    dr.bottomprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(0, 1000, 100, 900)
    dr.leftprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(100, 1000, 100, 900)
    dr.rightprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(100, 900, 100, 900)

    dr2 = layout[1, 2] = DebugRect()
    @test nrows(layout) == 1 && ncols(layout) == 2
    colgap!(layout, 1, Fixed(0))

    @test computedbboxobservable(dr)[].widths == computedbboxobservable(dr2)[].widths == Float32[400.0, 800.0]
end

@testset "GridLayout Outside AlignMode" begin
    bbox = Observable(BBox(0, 1000, 0, 1000)) # just as observable for bbox conversion test
    layout = GridLayout(bbox = bbox, alignmode = Outside(100, 200, 50, 150))
    dr = layout[1, 1] = DebugRect()

    @test computedbboxobservable(dr)[] == BBox(100, 800, 50, 850)

    dr.topprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(100, 800, 50, 750)
    dr.bottomprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(100, 800, 150, 750)
    dr.leftprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(200, 800, 150, 750)
    dr.rightprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(200, 700, 150, 750)
end

@testset "GridLayout Inside AlignMode" begin
    bbox = BBox(0, 1000, 0, 1000)
    layout = GridLayout(bbox = bbox, alignmode = Inside())
    dr = layout[1, 1] = DebugRect()

    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 1000)

    dr.topprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 1000)
    dr.bottomprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 1000)
    dr.leftprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 1000)
    dr.rightprot[] = 100
    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 1000)
end

@testset "GridLayout Mixed AlignMode" begin
    bbox = BBox(0, 1000, 0, 1000)
    layout = GridLayout(bbox = bbox, alignmode = Mixed(left = 0, top = 100))
    dr = layout[1, 1] = DebugRect()

    @test GridLayoutBase.protrusion(layout, Left()) == 0
    @test GridLayoutBase.protrusion(layout, Right()) == 0
    @test GridLayoutBase.protrusion(layout, Bottom()) == 0
    @test GridLayoutBase.protrusion(layout, Top()) == 0

    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 900)

    dr.topprot[] = 100
    @test GridLayoutBase.protrusion(layout, Top()) == 0
    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 800)

    dr.bottomprot[] = 100
    @test GridLayoutBase.protrusion(layout, Bottom()) == 100
    @test computedbboxobservable(dr)[] == BBox(0, 1000, 0, 800)

    dr.leftprot[] = 100
    @test GridLayoutBase.protrusion(layout, Left()) == 0
    @test computedbboxobservable(dr)[] == BBox(100, 1000, 0, 800)

    dr.rightprot[] = 100
    @test GridLayoutBase.protrusion(layout, Right()) == 100
    @test computedbboxobservable(dr)[] == BBox(100, 1000, 0, 800)

    layout.alignmode[] = Mixed(
        left = Protrusion(50),
        right = Protrusion(60),
        bottom = Protrusion(70),
        top = Protrusion(80),
    )

    # set layout to forced protrusion alignment
    @test GridLayoutBase.protrusion(layout, Left()) == 50
    @test GridLayoutBase.protrusion(layout, Right()) == 60
    @test GridLayoutBase.protrusion(layout, Bottom()) == 70
    @test GridLayoutBase.protrusion(layout, Top()) == 80
    # bb of dr only depends on its protrusions now
    @test computedbboxobservable(dr)[] == BBox(100, 1000, 0, 800)

    # force different protrusions for dr
    dr.alignmode[] = Mixed(
        left = Protrusion(50),
        right = Protrusion(60),
        bottom = Protrusion(70),
        top = Protrusion(80),
    )
    # bb should follow
    @test computedbboxobservable(dr)[] == BBox(50, 940, 70, 920)
end

@testset "alignmodes and reported dimensions" begin
    gl = GridLayout()
    dr = gl[1, 1] = DebugRect(width = 200, height = 300, alignmode = Mixed(left = 1, right = 2, bottom = 3, top = 4))
    @test reporteddimensionsobservable(dr)[].inner == (203, 307)
    @test reporteddimensionsobservable(dr)[].outer == RectSides{Float32}(0, 0, 0, 0)
    dr.alignmode[] = Inside()
    @test reporteddimensionsobservable(dr)[].inner == (200, 300)
    @test reporteddimensionsobservable(dr)[].outer == RectSides{Float32}(0, 0, 0, 0)
    dr.alignmode[] = Mixed(left = Protrusion(10), right = Protrusion(10), bottom = Protrusion(10), top = Protrusion(10))
    @test reporteddimensionsobservable(dr)[].inner == (200, 300)
    @test reporteddimensionsobservable(dr)[].outer == RectSides{Float32}(10, 10, 10, 10)
end

@testset "assigning content to protrusions" begin

    bbox = BBox(0, 1000, 0, 1000)
    layout = GridLayout(bbox = bbox, alignmode = Outside(0))
    subgl = layout[1, 1] = GridLayout()

    subgl[1, 1, Left()] = DebugRect(width = Fixed(100))
    @test GridLayoutBase.protrusion(subgl, Left()) == 100

    subgl[1, 1, Top()] = DebugRect(height = 50)
    @test GridLayoutBase.protrusion(subgl, Top()) == 50

    subgl[1, 1, Right()] = DebugRect(width = 120)
    @test GridLayoutBase.protrusion(subgl, Right()) == 120

    subgl[1, 1, Bottom()] = DebugRect(height = 40)
    @test GridLayoutBase.protrusion(subgl, Bottom()) == 40

    subgl[1, 1, TopLeft()] = DebugRect(width = 200, height = 200)
    @test GridLayoutBase.protrusion(subgl, Left()) == 200
    @test GridLayoutBase.protrusion(subgl, Top()) == 200

    subgl[1, 1, TopRight()] = DebugRect(width = 210, height = 210)
    @test GridLayoutBase.protrusion(subgl, Right()) == 210
    @test GridLayoutBase.protrusion(subgl, Top()) == 210

    subgl[1, 1, BottomRight()] = DebugRect(width = 220, height = 220)
    @test GridLayoutBase.protrusion(subgl, Right()) == 220
    @test GridLayoutBase.protrusion(subgl, Bottom()) == 220

    subgl[1, 1, BottomLeft()] = DebugRect(width = 230, height = 230)
    @test GridLayoutBase.protrusion(subgl, Left()) == 230
    @test GridLayoutBase.protrusion(subgl, Bottom()) == 230

    # issue 66
    bbox = BBox(0, 1000, 0, 1000)
    layout = GridLayout(bbox = bbox, alignmode = Outside(0))
    subgl = layout[1, 1] = GridLayout()
    dr = subgl[1, 1, GridLayoutBase.Outer()] = DebugRect()
    @test GridLayoutBase.protrusion(subgl, Left()) == 0
    @test GridLayoutBase.protrusion(subgl, Right()) == 0
    @test GridLayoutBase.protrusion(subgl, Bottom()) == 0
    @test GridLayoutBase.protrusion(subgl, Top()) == 0

    @test width(computedbboxobservable(dr)[]) ≈ 1000
    @test height(computedbboxobservable(dr)[]) ≈ 1000

    subgl[1, 1] = DebugRect(width = 200, height = 300, leftprot = 10, rightprot = 20, bottomprot = 30, topprot = 40)
    @test GridLayoutBase.protrusion(subgl, Left()) == 10
    @test GridLayoutBase.protrusion(subgl, Right()) == 20
    @test GridLayoutBase.protrusion(subgl, Bottom()) == 30
    @test GridLayoutBase.protrusion(subgl, Top()) == 40

    @test width(computedbboxobservable(dr)[]) ≈ 200 + 10 + 20
    @test height(computedbboxobservable(dr)[]) ≈ 300 + 30 + 40
end


@testset "resizing through indexing out of range and trim!" begin

    bbox = BBox(0, 1000, 0, 1000)
    layout = GridLayout(bbox = bbox, alignmode = Outside(0))

    dr = layout[1, 1] = DebugRect()
    @test size(layout) == (1, 1)
    @test offsets(layout) == (0, 0)

    layout[1, 2] = dr
    @test size(layout) == (1, 2)
    @test offsets(layout) == (0, 0)

    layout[3, 2] = dr
    @test size(layout) == (3, 2)
    @test offsets(layout) == (0, 0)

    layout[4, 4] = dr
    @test size(layout) == (4, 4)
    @test offsets(layout) == (0, 0)

    layout[0, 1] = dr
    @test size(layout) == (5, 4)
    @test offsets(layout) == (-1, 0)

    layout[1, 0] = dr
    @test size(layout) == (5, 5)
    @test offsets(layout) == (-1, -1)

    layout[-1, -1] = dr
    @test size(layout) == (6, 6)
    @test offsets(layout) == (-2, -2)

    layout[3, 3] = dr
    trim!(layout)
    @test size(layout) == (1, 1)
    @test offsets(layout) == (-2, -2)
    # reset offsets to zero
    layout.offsets = (0, 0)

    layout[2:3, 4:5] = dr
    @test size(layout) == (3, 5)

    trim!(layout)
    @test size(layout) == (2, 2)
end


@testset "manually deleting rows / cols" begin
    layout = GridLayout(4, 4)

    deletecol!(layout, 2)
    @test size(layout) == (4, 3)

    deleterow!(layout, 3)
    @test size(layout) == (3, 3)

    deleterow!(layout, 1)
    @test size(layout) == (2, 3)

    deletecol!(layout, 1)
    @test size(layout) == (2, 2)

    deleterow!(layout, 2)
    @test size(layout) == (1, 2)

    deletecol!(layout, 2)
    @test size(layout) == (1, 1)

    @test_throws ErrorException deletecol!(layout, 2)
    @test_throws ErrorException deleterow!(layout, 2)
    @test_throws ErrorException deletecol!(layout, 1)
    @test_throws ErrorException deleterow!(layout, 1)

    dr = layout[1, 2] = DebugRect()
    @test length(layout.content) == 1
    deletecol!(layout, 2)
    @test isempty(layout.content)

    dr = layout[2, 1] = DebugRect()
    @test length(layout.content) == 1
    deleterow!(layout, 2)
    @test isempty(layout.content)
end

@testset "inserting rows / cols" begin

    layout = GridLayout(4, 4)
    dr1 = layout[1, 1] = DebugRect()
    dr2 = layout[1, 2:3] = DebugRect()
    dr3 = layout[1, 4] = DebugRect()
    dr4 = layout[2:3, 1] = DebugRect()
    dr5 = layout[4, 1] = DebugRect()
    dr6 = layout[2:3, 2:3] = DebugRect()
    dr7 = layout[1, 3] = DebugRect()
    dr8 = layout[3, 1] = DebugRect()

    @test_throws ErrorException insertcols!(layout, 0, 1)
    @test_throws ErrorException insertcols!(layout, 5, 1)
    @test_throws ErrorException insertrows!(layout, 0, 1)
    @test_throws ErrorException insertrows!(layout, 5, 1)

    insertcols!(layout, 3, 2)
    @test gridcontent(dr1).span.cols == 1:1
    @test gridcontent(dr2).span.cols == 2:5
    @test gridcontent(dr3).span.cols == 6:6

    insertrows!(layout, 3, 2)
    @test gridcontent(dr1).span.rows == 1:1
    @test gridcontent(dr4).span.rows == 2:5
    @test gridcontent(dr5).span.rows == 6:6

    @test gridcontent(dr6).span.cols == 2:5
    @test gridcontent(dr6).span.rows == 2:5

    @test gridcontent(dr7).span.cols == 5:5
    @test gridcontent(dr8).span.rows == 5:5
end

@testset "setting col and row sizes and gaps" begin
    bbox = BBox(0, 1000, 0, 1000)
    layout = GridLayout(3, 3, bbox = bbox, alignmode = Outside(0))

    colsize!(layout, 1, Fixed(10))
    @test layout.colsizes[1] == Fixed(10)

    colsize!(layout, 2, 20)
    @test layout.colsizes[2] == Fixed(20)

    rowsize!(layout, 1, Relative(0.2))
    @test layout.rowsizes[1] == Relative(0.2)

    rowsize!(layout, 2, 15.3)
    @test layout.rowsizes[2] == Fixed(15.3)

    @test_throws ErrorException colsize!(layout, 4, Auto())
    @test_throws ErrorException rowsize!(layout, 0, Auto())


    colgap!(layout, 1, Fixed(10))
    @test layout.addedcolgaps[1] == Fixed(10)
    rowgap!(layout, 2, Relative(0.3))
    @test layout.addedrowgaps[2] == Relative(0.3)

    colgap!(layout, 10)
    @test all(layout.addedcolgaps .== Ref(Fixed(10)))
    rowgap!(layout, 20)
    @test all(layout.addedrowgaps .== Ref(Fixed(20)))

    colgap!(layout, Fixed(30))
    @test all(layout.addedcolgaps .== Ref(Fixed(30)))
    rowgap!(layout, Fixed(40))
    @test all(layout.addedrowgaps .== Ref(Fixed(40)))

    @test_throws ErrorException colgap!(layout, 10, Fixed(10))
    @test_throws ErrorException rowgap!(layout, 10, Fixed(10))
end

@testset "some constructors" begin
    @test Outside() == Outside(0f0)
    @test Auto(2).ratio == 2.0
end

@testset "gridlayout constructor colsizes" begin
    gl = GridLayout(2, 2; colsizes = Fixed(10), rowsizes = Relative(0.5))

    @test gl.colsizes == GridLayoutBase.ContentSize[Fixed(10), Fixed(10)]
    @test gl.rowsizes == GridLayoutBase.ContentSize[Relative(0.5), Relative(0.5)]

    gl2 = GridLayout(2, 2;
        colsizes = GridLayoutBase.ContentSize[Fixed(10), Relative(0.3)],
        rowsizes = GridLayoutBase.ContentSize[Auto(false), Auto(true)])
    @test gl2.colsizes == GridLayoutBase.ContentSize[Fixed(10), Relative(0.3)]
    @test gl2.rowsizes == GridLayoutBase.ContentSize[Auto(false), Auto(true)]

    @test_throws ErrorException GridLayout(; colsizes = "abc")
    @test_throws ErrorException GridLayout(; rowsizes = missing)

    gl3 = GridLayout(3, 3; addedcolgaps = Fixed(20), addedrowgaps = Fixed(0))
    @test gl3.addedcolgaps == GridLayoutBase.GapSize[Fixed(20), Fixed(20)]
    @test gl3.addedrowgaps == GridLayoutBase.GapSize[Fixed(0), Fixed(0)]

    @test_throws ErrorException GridLayout(3, 1; addedcolgaps = "abc")
    @test_throws ErrorException GridLayout(1, 3; addedrowgaps = "abc")

    @test_throws ErrorException GridLayout(3, 1; addedcolgaps = [Fixed(20)])
    @test_throws ErrorException GridLayout(3, 1; addedrowgaps = [Fixed(30)])

    @test_throws ErrorException GridLayout(3, 1; rowsizes = [Fixed(20)])
    @test_throws ErrorException GridLayout(3, 2; colsizes = [Relative(0.4)])

    @test_throws ErrorException GridLayout(0, 1)
    @test_throws ErrorException GridLayout(1, 0)
end


@testset "printing gridlayouts" begin
    gl = GridLayout(3, 3)
    gl[1, 1] = DebugRect()
    gl[2:3, 4:5] = DebugRect()

    text_long = repr(MIME"text/plain"(), gl)
    @test text_long == """
    GridLayout[1:3, 1:5] with 2 children
     ┣━ [1, 1] DebugRect
     ┗━ [2:3, 4:5] DebugRect
    """
    text_short = repr(gl)
    @test text_short == "GridLayout[3, 5] (2 children)"

    subgl = gl[1, 2] = GridLayout()
    subgl[1:5, 3] = DebugRect()

    text_longer = repr(MIME"text/plain"(), gl)
    # this is actually a bit buggy with the newline space space newline at the end
    @test text_longer == "GridLayout[1:3, 1:5] with 3 children\n ┣━ [1, 1] DebugRect\n ┣━ [2:3, 4:5] DebugRect\n ┗━ [1, 2] GridLayout[1:5, 1:3] with 1 children\n   ┗━ [1:5, 3] DebugRect\n  \n"


    gl3 = GridLayout()
    gl4 = gl3[1, 1] = GridLayout()
    gl4[1, 1] = DebugRect()
    gl3[2, 2] = DebugRect()
    text_long_downconnection = repr(MIME"text/plain"(), gl3)

    # this is also a bit buggy for the same reason as above
    @test text_long_downconnection == "GridLayout[1:2, 1:2] with 2 children\n ┣━ [1, 1] GridLayout[1:1, 1:1] with 1 children\n ┃ ┗━ [1, 1] DebugRect\n ┃\n ┗━ [2, 2] DebugRect\n"
end

@testset "vector and array assigning" begin
    gl = GridLayout()
    gl[1, 1:3] = [DebugRect() for i in 1:3]
    @test size(gl) == (1, 3)

    gl2 = GridLayout()
    gl2[2:3, 2] = [DebugRect() for i in 1:2]
    @test size(gl2) == (3, 2)

    gl3 = GridLayout()
    gl3[1:3, 1:4] = [DebugRect() for i in 1:12]
    @test size(gl3) == (3, 4)

    gl4 = GridLayout()
    gl4[1:3, 1:4] = [DebugRect() for i in 1:3, j in 1:4]
    @test size(gl4) == (3, 4)

    @test_throws ErrorException gl[1, 1:3] = [DebugRect() for i in 1:2]
    @test_throws ErrorException gl[1:3, 2] = [DebugRect() for i in 1:2]
    @test_throws ErrorException gl[1:3, 1:3] = [DebugRect() for i in 1:10]
    @test_throws ErrorException gl[1:3, 1:3] = [DebugRect() for i in 1:3, j in 1:4]

    gl5 = GridLayout()
    gl5[] = [DebugRect() for i in 1:2, j in 1:3]
    @test size(gl5) == (2, 3)

    gl6 = GridLayout()
    gl6[:v] = [DebugRect() for i in 1:3]
    @test size(gl6) == (3, 1)

    gl7 = GridLayout()
    gl7[:h] = [DebugRect() for i in 1:3]
    @test size(gl7) == (1, 3)

    @test_throws ErrorException gl7[:abc] = [DebugRect() for i in 1:3]
    @test_throws ErrorException gl7[] = [DebugRect() for i in 1:3]
end

@testset "grid api" begin

    gl1 = grid!([1:2, 1:2] => DebugRect(), [3, :] => DebugRect())
    @test size(gl1) == (3, 2)
    @test gl1.content[1].span == GridLayoutBase.Span(1:2, 1:2)
    @test gl1.content[2].span == GridLayoutBase.Span(3:3, 1:2)

    gl2 = grid!([DebugRect() for i in 1:3, j in 1:2])
    @test size(gl2) == (3, 2)
    for i in 1:3, j in 1:2
        n = (i - 1) * 2 + j
        @test gl2.content[n].span == GridLayoutBase.Span(i:i, j:j)
    end

    gl3 = vbox!(DebugRect(), DebugRect())
    @test size(gl3) == (2, 1)
    for i in 1:2
        @test gl3.content[i].span == GridLayoutBase.Span(i:i, 1:1)
    end

    gl4 = hbox!(DebugRect(), DebugRect())
    @test size(gl4) == (1, 2)
    for i in 1:2
        @test gl4.content[i].span == GridLayoutBase.Span(1:1, i:i)
    end
end

@testset "gridnest" begin
    layout = GridLayout()
    dr = layout[1:2, 3:4] = DebugRect()
    subgl = gridnest!(layout, 1:2, 3:4)

    @test size(subgl) == (2, 2)
    @test subgl.content[1].span == GridLayoutBase.Span(1:2, 1:2)
end

@testset "invalid removal" begin
    layout = GridLayout()
    dr = layout[1, 1] = DebugRect()
    # remove the item outside of the normal path
    deleteat!(layout.content, 1)
    # place the item somewhere else, this should error now
    @test_throws ErrorException layout[1, 2] = dr
end

@testset "equal protrusion gaps" begin
    bbox = BBox(0, 1000, 0, 700)
    layout = GridLayout(bbox = bbox, alignmode = Outside(0))
    subgl = layout[1, 1] = GridLayout(3, 3, equalprotrusiongaps = (true, true),
        addedcolgaps = Fixed(0), addedrowgaps = Fixed(0))
    subgl[1, 1, BottomRight()] = DebugRect(width = 100, height = 100)

    dr1 = subgl[1, 1] = DebugRect()
    dr2 = subgl[2, 2] = DebugRect()
    dr3 = subgl[3, 3] = DebugRect()

    @test width(computedbboxobservable(dr1)[]) ≈ (1000 - 2 * 100) / 3.0f0
    @test width(computedbboxobservable(dr2)[]) ≈ (1000 - 2 * 100) / 3.0f0
    @test width(computedbboxobservable(dr3)[]) ≈ (1000 - 2 * 100) / 3.0f0
    @test height(computedbboxobservable(dr1)[]) ≈ (700 - 2 * 100) / 3.0f0
    @test height(computedbboxobservable(dr2)[]) ≈ (700 - 2 * 100) / 3.0f0
    @test height(computedbboxobservable(dr3)[]) ≈ (700 - 2 * 100) / 3.0f0
end

@testset "getindex gridposition" begin
    layout = GridLayout()
    dr = layout[2, 2] = DebugRect()

    @test layout[2, 2] == GridPosition(layout, 2, 2)
    @test layout[end, end] == GridPosition(layout, 2, 2)
    @test_throws ErrorException layout[2, 2, end]

    gp = GridPosition(layout, 1, 1)
    gp[] = dr
    @test gridcontent(dr).span == GridLayoutBase.Span(1:1, 1:1)
end

@testset "gridposition contents" begin
    layout = GridLayout()
    dr1 = layout[1, 1] = DebugRect()
    dr2 = layout[1, 2] = DebugRect()
    dr3 = layout[2, 1] = DebugRect()
    dr4 = layout[2, 2] = DebugRect()

    co = contents(layout[1, 1])
    @test co == [dr1]

    co = contents(layout[1:2, 1])
    @test co == [dr1, dr3]

    co = contents(layout[2, 1:2])
    @test co == [dr3, dr4]

    co = contents(layout[:, :])
    @test co == [dr1, dr2, dr3, dr4]

    dr5 = layout[2, 2, Right()] = DebugRect()

    co = contents(layout[:, :]) # implicit Inner() side
    @test co == [dr1, dr2, dr3, dr4]

    @test contents(layout[2, 2, Right()]) == [dr5]

    dr6 = layout[1:2, 2] = DebugRect()
    @test contents(layout[1:2, 2]) == [dr2, dr4, dr6]
    @test contents(layout[1:2, 2], exact = true) == [dr6]

    @test contents(layout) == [dr1, dr2, dr3, dr4, dr5, dr6]
end

@testset "span containment" begin
    Span = GridLayoutBase.Span
    @test Span(1:2, 2:3) in Span(1:2, 2:3)
    @test Span(1:2, 2:3) in Span(0:3, 1:4)
    @test !(Span(0:3, 1:4) in Span(1:2, 2:3))
    @test !(Span(1:2, 1:4) in Span(1:2, 2:3))
    @test !(Span(0:3, 2:3) in Span(1:2, 2:3))
end

@testset "layoutobservables undefined" begin
    struct MyType end
    @test_throws ErrorException GridLayoutBase.layoutobservables(MyType())
end

@testset "determine gridlayout size" begin
    gl = GridLayout(;alignmode = Outside(0))
    gl[1, 1] = DebugRect(width = 800, height = 600)

    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Row()) == 600
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Col()) == 800

    gl[1, 1, Left()] = DebugRect(width = 200)
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Col()) == 800 + 200
    gl[1, 1, Right()] = DebugRect(width = 200)
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Col()) == 800 + 200 + 200

    gl[1, 1, Top()] = DebugRect(height = 100)
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Row()) == 600 + 100
    gl[1, 1, Bottom()] = DebugRect(height = 100)
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Row()) == 600 + 100 + 100

    gl.alignmode[] = Outside(50)
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Col()) == 800 + 200 + 200 + 2 * 50
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Row()) == 600 + 100 + 100 + 2 * 50

    gl.alignmode[] = Inside()
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Col()) == 800
    @test GridLayoutBase.determinedirsize(gl, GridLayoutBase.Row()) == 600
end

@testset "alignment" begin
    boxwidth = 1000
    boxheight = 800

    gl = GridLayout(; bbox = (0, boxwidth, 0, boxheight), alignmode = Outside(0))
    gl[1, 1] = DebugRect(width = boxwidth, height = boxheight)
    halign = Observable{Any}(:center)
    valign = Observable{Any}(:center)

    rectwidth = 400
    rectheight = 200

    dr = gl[1, 1] = DebugRect(width = rectwidth, height = 200, halign = halign, valign = valign)

    @test computedbboxobservable(dr)[] == BBox(boxwidth/2 - rectwidth/2, boxwidth/2 + rectwidth/2, boxheight/2 - rectheight/2, boxheight/2 + rectheight/2)
    halign[] = :left
    @test computedbboxobservable(dr)[] == BBox(0, rectwidth, boxheight/2 - rectheight/2, boxheight/2 + rectheight/2)
    halign[] = :right
    @test computedbboxobservable(dr)[] == BBox(boxwidth - rectwidth, boxwidth, boxheight/2 - rectheight/2, boxheight/2 + rectheight/2)
    valign[] = :top
    @test computedbboxobservable(dr)[] == BBox(boxwidth - rectwidth, boxwidth, boxheight - rectheight, boxheight)
    valign[] = :bottom
    @test computedbboxobservable(dr)[] == BBox(boxwidth - rectwidth, boxwidth, 0, rectheight)

    valign[] = 0.5
    @test computedbboxobservable(dr)[] == BBox(boxwidth - rectwidth, boxwidth,  boxheight/2 - rectheight/2, boxheight/2 + rectheight/2)
    halign[] = 0.5
    @test computedbboxobservable(dr)[] == BBox(boxwidth/2 - rectwidth/2, boxwidth/2 + rectwidth/2,  boxheight/2 - rectheight/2, boxheight/2 + rectheight/2)

    @test_throws ErrorException valign[] = :abc
    valign[] = 0.5
    @test_throws ErrorException halign[] = :abc
end


@testset "invalid gridlayout construction" begin
    @test_throws ErrorException GridLayout(2, 2; rowsizes = [Fixed(10)])
    @test_throws ErrorException GridLayout(2, 2; colsizes = [Fixed(10)])
    @test_throws ErrorException GridLayout(2, 2; addedrowgaps = [Fixed(10), Fixed(10)])
    @test_throws ErrorException GridLayout(2, 2; addedcolgaps = [Fixed(10), Fixed(10)])
    @test_throws ErrorException GridLayout(2, 2; rowsizes = [Fixed(10), Fixed(10)], addedrowgaps = [Fixed(10), Fixed(10)])
    @test_throws ErrorException GridLayout(2, 2; colsizes = [Fixed(10), Fixed(10)], addedcolgaps = [Fixed(10), Fixed(10)])
end

@testset "tellsize" begin
    dr = DebugRect(width = 100, height = 200, tellwidth = true, tellheight = false)
    @test reporteddimensionsobservable(dr)[].inner == (100, nothing)
    dr = DebugRect(width = 100, height = 200, tellwidth = false, tellheight = true)
    @test reporteddimensionsobservable(dr)[].inner == (nothing, 200)
end


@testset "aspect sizes referencing auto sizes" begin
    bbox = BBox(0, 1000, 0, 1000)
    layout = GridLayout(2, 2, bbox = bbox, alignmode = Outside(0))

    colgap!(layout, 0)
    rowgap!(layout, 0)

    dr = layout[1, 1] = DebugRect()

    colsize!(layout, 1, Aspect(1, 1.5))
    @test computedbboxobservable(dr)[] == BBox(0, 750, 500, 1000)

    colsize!(layout, 1, Auto())

    rowsize!(layout, 1, Aspect(1, 1.5))
    @test computedbboxobservable(dr)[] == BBox(0, 500, 250, 1000)

    @test_throws ErrorException colsize!(layout, 1, Aspect(1, 1))
end

@testset "integer rect2 suggestedbbox" begin
    layout = GridLayout(bbox = Observable(GridLayoutBase.GeometryBasics.Rect(0, 10, 20, 30)))
    @test suggestedbboxobservable(layout)[] == GridLayoutBase.GeometryBasics.Rect2f(0, 10, 20, 30)
end

@testset "GridSubpositions" begin
    l = GridLayout()
    gp = l[1, 1]
    @test gp isa GridPosition
    gsp = gp[1, 1]
    @test gsp isa GridSubposition
    @test isempty(contents(gp))
    r = gsp[] = DebugRect()
    @test content(gp) isa GridLayout
    @test content(gsp) == r

    r2 = l[1, 1][1, 2] = DebugRect()
    @test content(l[1, 1][1, 2]) == r2
    r3 = l[1, 1][1, 3][1, 1] = DebugRect()
    @test content(l[1, 1][1, 3][1, 1]) == r3
end

@testset "Parents" begin
    g = GridLayout()
    @test GridLayoutBase.parent(g) === nothing
    @test GridLayoutBase.top_parent(g) === nothing
    g2 = GridLayout()
    @test GridLayoutBase.parent(g2) === nothing
    g[1, 1] = g2
    @test GridLayoutBase.parent(g2) === g
    @test GridLayoutBase.top_parent(g2) === nothing
    @test GridLayoutBase.top_parent_grid(g2) === g

    g3 = GridLayout()
    @test GridLayoutBase.parent(g3) === nothing
    g2[1, 1] = g3
    @test GridLayoutBase.parent(g3) === g2
    @test GridLayoutBase.top_parent(g3) === nothing
    @test GridLayoutBase.top_parent_grid(g3) === g

    # make some arbitrary parent object with an id
    p = Dict()
    g.parent = p
    @test GridLayoutBase.parent(g) === p
    @test GridLayoutBase.top_parent(g) === p
    @test GridLayoutBase.top_parent(g2) === p
    @test GridLayoutBase.top_parent(g3) === p
    @test GridLayoutBase.top_parent_grid(g2) === g
    @test GridLayoutBase.top_parent_grid(g3) === g
end

@testset "Number of updates" begin
    g = GridLayout()
    n = Ref(0)
    on(g.layoutobservables.suggestedbbox) do _
        n[] += 1
    end

    g2 = GridLayout()
    g[1, 1] = g2
    @test n[] == 0

    m = Ref(0)
    on(g2.layoutobservables.suggestedbbox) do _
        m[] += 1
    end
    for i in 1:10
        g2[1, i] = GridLayout()
    end
    # one update for each gridlayout
    @test m[] == 10
    # g shouldn't have changed
    @test n[] == 0
    with_updates_suspended(g2) do
        for i in 1:10
            g2[1, i] = GridLayout()
        end
    end
    # only one update should have happened at the end
    @test m[] == 11
    # still nothing for g
    @test n[] == 0
end

@testset "Number of updates 2" begin
    gl = GridLayout()
    gl2 = GridLayout(gl[1, 1])
    dr = gl2[1, 1] = DebugRect(width = 100, height = 100)
    dr2 = gl2[1, 2] = DebugRect(width =  100, height = 200)
    n = Ref(0)
    on(dr2.layoutobservables.suggestedbbox) do bb
        n[] += 1
    end
    dr2.rightprot[] = 10
    @test n[] == 1
end

@testset "GridLayout alignment when solved size mismatches suggested bbox" begin
    let
        bbox = BBox(0, 2000, 0, 1000)
        outer = GridLayout(bbox = bbox, alignmode = Outside(0), halign = :center)
        dr1 = outer[1, 1] = DebugRect()
        dr2 = outer[1, 2] = DebugRect()
        colsize!(outer, 2, 500)
        colsize!(outer, 1, Aspect(1, 1))
        colgap!(outer, 0)
        @test computedbboxobservable(dr1)[] == BBox(250, 1250, 0, 1000)
        @test computedbboxobservable(dr2)[] == BBox(1250, 1750, 0, 1000)

        outer.halign = :left
        @test computedbboxobservable(dr1)[] == BBox(0, 1000, 0, 1000)
        @test computedbboxobservable(dr2)[] == BBox(1000, 1500, 0, 1000)

        outer.halign = :right
        @test computedbboxobservable(dr1)[] == BBox(500, 1500, 0, 1000)
        @test computedbboxobservable(dr2)[] == BBox(1500, 2000, 0, 1000)
    end
    let
        bbox = BBox(0, 1000, 0, 2000)
        outer = GridLayout(bbox = bbox, alignmode = Outside(0), valign = :center)
        dr1 = outer[1, 1] = DebugRect()
        dr2 = outer[2, 1] = DebugRect()
        rowsize!(outer, 2, 500)
        rowsize!(outer, 1, Aspect(1, 1))
        rowgap!(outer, 0)
        @test computedbboxobservable(dr1)[] == BBox(0, 1000, 750, 1750)
        @test computedbboxobservable(dr2)[] == BBox(0, 1000, 250, 750)

        outer.valign = :top
        @test computedbboxobservable(dr1)[] == BBox(0, 1000, 1000, 2000)
        @test computedbboxobservable(dr2)[] == BBox(0, 1000, 500, 1000)

        outer.valign = :bottom
        @test computedbboxobservable(dr1)[] == BBox(0, 1000, 500, 1500)
        @test computedbboxobservable(dr2)[] == BBox(0, 1000, 0, 500)
    end
end

@testset "tight_bbox" begin
    bbox = BBox(0, 2000, 0, 1000)

    gl = GridLayout(bbox = bbox, alignmode = Outside(0), halign = :center)
    dr1 = gl[1, 1] = DebugRect()
    dr2 = gl[1, 2] = DebugRect()
    colsize!(gl, 2, 500)
    colsize!(gl, 1, Aspect(1, 1))
    colgap!(gl, 0)

    @test tight_bbox(gl) == BBox(250, 1750, 0, 1000)
    gl.alignmode[] = Outside(0, 100, 0, 200)
    # inner height now 800, so colwidth 1 also 800, plus 500 = 1300, plus padding 1400
    # but shifted because of unequal padding
    @test tight_bbox(gl) == BBox(300, 1700, 0, 1000)

    dr1.topprot[] = 100
    dr1.leftprot[] = 50
    # inner height now 700, so colwidth 1 also 700, plus 500 = 1200, plus padding + leftprot = 1350
    @test tight_bbox(gl) == BBox(325, 1675, 0, 1000)

    gl.alignmode[] = Inside()
    # padding and protrusions are gone, so height is again 1000
    @test tight_bbox(gl) == BBox(250, 1750, 0, 1000)

    gl.alignmode[] = Mixed()
    # not implemented yet
    @test_throws ErrorException tight_bbox(gl)
end

@testset "offset row/col auto size" begin
    bbox = BBox(0, 1000, 0, 1000)
    gl = GridLayout(bbox = bbox, alignmode = Outside(0), halign = :center)
    dr1 = gl[0, 1] = DebugRect(height = 200)
    dr2 = gl[1, 0] = DebugRect(width = 100)
    dr3 = gl[1, 1] = DebugRect()
    colgap!(gl, 0)
    rowgap!(gl, 0)

    @test GridLayoutBase.determinedirsize(0, gl, GridLayoutBase.Col()) == 100
    @test GridLayoutBase.determinedirsize(0, gl, GridLayoutBase.Row()) == 200

    @test suggestedbboxobservable(dr1)[] == BBox(100, 1000, 800, 1000)
    @test suggestedbboxobservable(dr2)[] == BBox(0, 100, 0, 800)
    @test suggestedbboxobservable(dr3)[] == BBox(100, 1000, 0, 800)
end

@testset "offset aspect" begin
    bbox = BBox(0, 1000, 0, 1000)
    gl = GridLayout(bbox = bbox, alignmode = Outside(0), halign = :center)
    # make columns and rows offset
    gl[0, 0] = DebugRect()
    colgap!(gl, 0)
    rowgap!(gl, 0)
    # aspect refers to row 0 
    colsize!(gl, 1, Aspect(0, 1.5))

    maxgrid, gridboxes = GridLayoutBase.compute_rowcols(gl, suggestedbboxobservable(gl)[])
    @test gridboxes.lefts == [0, 250]
    @test gridboxes.rights == [250, 1000]
    @test gridboxes.tops == [1000, 500]
    @test gridboxes.bottoms == [500, 0]

    bbox = BBox(0, 1000, 0, 1000)
    gl = GridLayout(bbox = bbox, alignmode = Outside(0), halign = :center)
    # make columns and rows offset
    gl[0, 0] = DebugRect()
    colgap!(gl, 0)
    rowgap!(gl, 0)
    # aspect refers to column 0
    rowsize!(gl, 1, Aspect(0, 1.5))

    maxgrid, gridboxes = GridLayoutBase.compute_rowcols(gl, suggestedbboxobservable(gl)[])
    @test gridboxes.lefts == [0, 500]
    @test gridboxes.rights == [500, 1000]
    @test gridboxes.tops == [1000, 750]
    @test gridboxes.bottoms == [750, 0]
end

# issue 37
@testset "Aspect indexing bug" begin
    gl = GridLayout()
    gl[0, 1] = DebugRect(height = 200)
    @test_nowarn colsize!(gl, 1, Aspect(0, 1.0))

    gl = GridLayout()
    gl[1, 0] = DebugRect(width = 200)
    @test_nowarn rowsize!(gl, 1, Aspect(0, 1.0))
end

@testset "colon rows/cols with offsets" begin
    gl = GridLayout()
    gl[0, 0] = GridLayout()
    g1 = gl[-1, :] = GridLayout()
    g2 = gl[:, -1] = GridLayout()
    @test gridcontent(g1).span == GridLayoutBase.Span(-1:-1, 0:1)
    @test gridcontent(g2).span == GridLayoutBase.Span(-1:1, -1:-1)
end

# https://github.com/JuliaPlots/Makie.jl/issues/2018
@testset "fixed size dirgaps" begin
    gl = GridLayout(width = 800, height = 600)
    gl[1, 1] = DebugRect(width = 600, height = 600)
    @test begin
        gl[0, 1] = DebugRect(height = 40, width = 100)
        true
    end
end
@testset "Effective protrusions" begin
    bbox = BBox(0, 1000, 0, 1000)
    gl = GridLayout(bbox = bbox, alignmode = Outside(0))

    dr1 = gl[1, 1] = DebugRect(rightprot = 50, bottomprot = 100, alignmode = Inside())
    @test GridLayoutBase.protrusionsobservable(dr1)[] == RectSides{Float32}(0, 50, 100, 0)
    @test GridLayoutBase.suggestedbboxobservable(dr1)[] == BBox(0, 950, 100, 1000)

    dr1.alignmode[] = Mixed(right = Protrusion(0), bottom = Protrusion(0))
    @test GridLayoutBase.protrusionsobservable(dr1)[] == RectSides{Float32}(0, 50, 100, 0)
    @test reporteddimensionsobservable(dr1)[].outer == RectSides{Float32}(0, 0, 0, 0)
    @test GridLayoutBase.suggestedbboxobservable(dr1)[] == BBox(0, 1000, 0, 1000)
    @test GridLayoutBase.computedbboxobservable(dr1)[] == BBox(0, 1000, 0, 1000)

    dr1.alignmode[] = Mixed(right = 50, bottom = 50)
    @test GridLayoutBase.protrusionsobservable(dr1)[] == RectSides{Float32}(0, 50, 100, 0)
    @test reporteddimensionsobservable(dr1)[].outer == RectSides{Float32}(0, 0, 0, 0)
    @test GridLayoutBase.suggestedbboxobservable(dr1)[] == BBox(0, 1000, 0, 1000)
    @test GridLayoutBase.computedbboxobservable(dr1)[] == BBox(0, 900, 150, 1000)

    dr1.alignmode[] = Mixed(right = Protrusion(50), bottom = Protrusion(50), left = Protrusion(50), top = Protrusion(50))
    @test GridLayoutBase.protrusionsobservable(dr1)[] == RectSides{Float32}(0, 50, 100, 0)
    @test reporteddimensionsobservable(dr1)[].outer == RectSides{Float32}(50, 50, 50, 50)
    @test GridLayoutBase.suggestedbboxobservable(dr1)[] == BBox(50, 950, 50, 950)
    @test GridLayoutBase.computedbboxobservable(dr1)[] == BBox(50, 950, 50, 950)

    dr1.layoutobservables.protrusions[] = RectSides{Float32}(0, 0, 0, 0)
    @test GridLayoutBase.protrusionsobservable(dr1)[] == RectSides{Float32}(0, 0, 0, 0)
    @test reporteddimensionsobservable(dr1)[].outer == RectSides{Float32}(50, 50, 50, 50)

    dr1.alignmode[] = Mixed(left = Protrusion(1), right = Protrusion(2), bottom = Protrusion(3), top = Protrusion(4))
    @test GridLayoutBase.protrusionsobservable(dr1)[] == RectSides{Float32}(0, 0, 0, 0)
    @test reporteddimensionsobservable(dr1)[].outer == RectSides{Float32}(1, 2, 3, 4)

    gl = GridLayout()
    @test GridLayoutBase.protrusionsobservable(gl)[] == RectSides{Float32}(0, 0, 0, 0)
    gl[1, 1, Right()] = DebugRect(width = 200)
    @test GridLayoutBase.protrusionsobservable(gl)[] == RectSides{Float32}(0, 200, 0, 0)
    @test reporteddimensionsobservable(gl)[].outer == RectSides{Float32}(0, 200, 0, 0)
end

@testset "GridLayout GridPosition/GridSubposition constructor" begin
    gl = GridLayout()
    gl2 = GridLayout(gl[1, 1])
    @test gl2.parent == gl
    @test gl2.layoutobservables.gridcontent[].span == GridLayoutBase.Span(1:1, 1:1)
    gl3 = GridLayout(gl[1, 2][1, 1])
    @test gl3.parent != gl
    @test gl3.parent == gl.content[2].content
    @test gl3.layoutobservables.gridcontent[].span == GridLayoutBase.Span(1:1, 1:1)
    @test gl.content[2].content.layoutobservables.gridcontent[].span == GridLayoutBase.Span(1:1, 2:2)
end

@testset "mixed alignmode bug" begin
    gl = GridLayout(bbox = BBox(0, 1000, 0, 500), alignmode = Outside(0))
    gl2 = GridLayout(gl[1, 1])
    dr1 = gl2[1, 1] = DebugRect()
    dr2 = gl2[1, 2] = DebugRect()
    dr3 = gl2[2, 1] = DebugRect()
    dr4 = gl2[2, 2] = DebugRect(width = 200)
    colgap!(gl2, 0)
    rowgap!(gl2, 0)
    @test reporteddimensionsobservable(dr4)[].inner == (200, nothing)
    @test computedbboxobservable(dr4)[] == BBox(800, 1000, 0, 250)
    @test suggestedbboxobservable(dr4)[] == BBox(800, 1000, 0, 250)
    @test reporteddimensionsobservable(dr4)[].outer == RectSides(0f0, 0f0, 0f0, 0f0)
    dr4.rightprot[] = 100
    @test reporteddimensionsobservable(dr4)[].inner == (200, nothing)
    @test reporteddimensionsobservable(dr4)[].outer == RectSides(0f0, 100f0, 0f0, 0f0)
    @test suggestedbboxobservable(dr4)[] == BBox(700, 900, 0, 250)
    @test computedbboxobservable(dr4)[] == BBox(700, 900, 0, 250)
    dr4.alignmode[] = Outside(0)
    @test reporteddimensionsobservable(dr4)[].inner == (300, nothing)
    @test reporteddimensionsobservable(dr4)[].outer == RectSides(0f0, 0f0, 0f0, 0f0)
    @test suggestedbboxobservable(dr4)[] == BBox(700, 1000, 0, 250)
    @test computedbboxobservable(dr4)[] == BBox(700, 900, 0, 250)
end

halign2shift(align::HorizontalAlignment)::Float32 = Float32(align.x)
halign2shift(align::Number)::Float32 = Float32(align)
function halign2shift(align::Symbol)::Float32
    align == :left && return 0.0f0
    align == :center && return 0.5f0
    align == :right && return 1.0f0
    error("Invalid horizontal alignment $align (only Real or :left, :center, or :right allowed).")
end

valign2shift(align::VerticalAlignment)::Float32 = Float32(align.x)
valign2shift(align::Number)::Float32 = Float32(align)
function valign2shift(align::Symbol)::Float32
    align == :bottom && return 0.0f0
    align == :center && return 0.5f0
    align == :top && return 1.0f0
    error("Invalid vertical alignment $align (only Real or :bottom, :center, or :top allowed).")
end

function align_shift_tuple(halign, valign)
    return (halign2shift(halign), valign2shift(valign))
end

function LayoutObservables(width::Observable, height::Observable,
        tellwidth::Observable, tellheight::Observable, halign::Observable,
        valign::Observable, alignmode::Observable = Observable{AlignMode}(Inside());
        suggestedbbox = nothing,
        protrusions = nothing,
        gridcontent = nothing,
        block_updates::Bool = false)

    width_obs = convert(Observable{SizeAttribute}, width)
    height_obs = convert(Observable{SizeAttribute}, height)
    sizeobservable = sizeobservable!(width_obs, height_obs)
    alignment = map(align_shift_tuple, halign, valign)

    suggestedbbox_observable = make_suggestedbbox!(suggestedbbox)
    protrusions = make_protrusions!(protrusions)

    tellsizeobservable = map(tuple, tellwidth, tellheight)

    gridcontent_ref = Ref{Optional{GridContent{GridLayout}}}(gridcontent)

    autosizeobservable = Observable{NTuple{2, Optional{Float32}}}((nothing, nothing))
    reporteddimensions = make_reporteddimensions!(sizeobservable, autosizeobservable, tellsizeobservable, protrusions, alignmode)
    computedbbox = make_computedbbox!(suggestedbbox_observable, reporteddimensions, alignment, sizeobservable, autosizeobservable,
        alignmode, protrusions, gridcontent_ref)

    LayoutObservables{GridLayout}(
        suggestedbbox_observable,
        protrusions,
        reporteddimensions,
        autosizeobservable,
        computedbbox,
        gridcontent_ref,
        Ref{Bool}(block_updates),
    )
end

maprectsides(f) = RectSides(map(f, (:left, :right, :bottom, :top))...)

function effective_protrusion(prot::RectSides, @nospecialize(al::AlignMode))
    x = if al isa Inside
        prot
    elseif al isa Outside
        RectSides{Float32}(0, 0, 0, 0)
    elseif al isa Mixed
        maprectsides() do side
            # normal inside mode
            if isnothing(getfield(al.sides, side))
                getfield(prot, side)
            # protrusion override
            elseif getfield(al.sides, side) isa Protrusion
                getfield(al.sides, side).p
            # outside mode
            else
                0f0
            end
        end
    end
end

make_suggestedbbox!(n::Nothing) = Observable(BBox(0, 100, 0, 100))
make_suggestedbbox!(tup::Tuple) = Observable(BBox(tup...))
make_suggestedbbox!(bbox::Rect{2}) = Observable(Rect2f(bbox))
make_suggestedbbox!(observable::Observable{Rect2f}) = observable
function make_suggestedbbox!(observable::Observable{<:Rect{2}})
    bbox = Observable(Rect2f(observable[]))
    on(observable) do o
        bbox[] = Rect2f(o)
    end
    bbox
end

make_protrusions!(p::Nothing) = Observable(RectSides{Float32}(0, 0, 0, 0))
make_protrusions!(p::Observable{RectSides{Float32}}) = p
make_protrusions!(p::RectSides{Float32}) = Observable(p)

function sizeobservable!(widthattr::Observable{SizeAttribute}, heightattr::Observable{SizeAttribute})
    sizeattrs = Observable{Tuple{SizeAttribute, SizeAttribute}}((widthattr[], heightattr[]))
    onany(widthattr, heightattr) do w, h
        sizeattrs[] = (w, h)
    end
    sizeattrs
end

function make_reporteddimensions!(sizeattrs, autosizeobservable::Observable{NTuple{2, Optional{Float32}}}, tellsizeobservable, protrusions, alignmode)

    # set up rsizeobservable with correct type manually
    rdimobservable = Observable{Dimensions}(Dimensions((nothing, nothing), RectSides(0f0, 0f0, 0f0, 0f0)))

    map!(_reporteddimensionsobservable, rdimobservable, sizeattrs, autosizeobservable, tellsizeobservable, protrusions, alignmode)

    # # trigger first value
    # notify(sizeattrs)

    rdimobservable
end

function _reporteddimensionsobservable(
        @nospecialize(sizeattrs::Tuple{SizeAttribute,SizeAttribute}),
        @nospecialize(autosize::Tuple{AutoSize,AutoSize}),
        tellsizeobservable::Tuple{Bool,Bool},
        protrusions,
        alignmode,
    )

    outer = effective_protrusion(protrusions, alignmode)

    wattr, hattr = sizeattrs
    wauto, hauto = autosize
    tellw, tellh = tellsizeobservable

    wsize = computed_size(wattr, wauto, tellw)
    hsize = computed_size(hattr, hauto, tellh)

    inner = if alignmode isa Inside
        (wsize, hsize)
    elseif alignmode isa Outside
        (isnothing(wsize) ? nothing : wsize + protrusions.left + protrusions.right + alignmode.padding.left + alignmode.padding.right,
         isnothing(hsize) ? nothing : hsize + protrusions.top + protrusions.bottom + alignmode.padding.top + alignmode.padding.bottom)
    elseif alignmode isa Mixed
        w = if isnothing(wsize)
            nothing
        else
            w = wsize
            if alignmode.sides.left isa Float32
                w += protrusions.left + alignmode.sides.left
            elseif alignmode.sides.left isa Protrusion
                w
            end
            if alignmode.sides.right isa Float32
                w += protrusions.right + alignmode.sides.right
            elseif alignmode.sides.right isa Protrusion
                w
            end
            w
        end
        h = if isnothing(hsize)
            nothing
        else
            h = hsize
            if alignmode.sides.bottom isa Float32
                h += protrusions.bottom + alignmode.sides.bottom
            elseif alignmode.sides.bottom isa Protrusion
                h
            end
            if alignmode.sides.top isa Float32
                h += protrusions.top + alignmode.sides.top
            elseif alignmode.sides.top isa Protrusion
                h
            end
            h
        end
        (w, h)
    else
        error("Unknown alignmode $alignmode")
    end

    Dimensions(inner, outer)
end

function computed_size(sizeattr, autosize, tellsize)

    if !tellsize
        return nothing
    end

    if sizeattr === nothing
        nothing
    elseif sizeattr isa Real
        Float32(sizeattr)
    elseif sizeattr isa Fixed
        sizeattr.x
    elseif sizeattr isa Relative
        nothing
    elseif sizeattr isa Auto
        autosize
    else
        error("""
            Invalid size attribute $sizeattr.
            Can only be Nothing, Fixed, Relative, Auto or Real""")
    end
end


function make_computedbbox!(
    suggestedbbox::Observable{Rect2f},
    reporteddimensions::Observable{Dimensions},
    alignment::Observable,
    sizeattrs::Observable,
    autosizeobservable::Observable{NTuple{2, Optional{Float32}}},
    alignmode, protrusions, gridcontent_ref)

    computedbbox = Observable(BBox(0, 100, 0, 100))

    # suggestedbbox and alignment don't affect the parent gridlayout
    onany(suggestedbbox, alignment) do sbbox, ali
        update_computedbbox!(computedbbox, sbbox, ali, reporteddimensions[], alignmode[], protrusions[], sizeattrs, autosizeobservable)
    end

    # these will trigger the update of a parent gridlayout if there is one, so an update
    # through suggestedbbox will come back after the parent has updated, so here we only update if
    # the object is standalone
    onany(reporteddimensions) do rdims
        if gridcontent_ref[] === nothing
            update_computedbbox!(computedbbox, suggestedbbox[], alignment[], rdims, alignmode[], protrusions[], sizeattrs, autosizeobservable)
        end
    end

    computedbbox
end

function update_computedbbox!(computedbbox, suggestedbbox, alignment, reporteddimensions, alignmode, protrusions, sizeattrs, autosizeobservable)

    bw = width(suggestedbbox)
    bh = height(suggestedbbox)

    # we only passively retrieve sizeattrs here because if they change
    # they also trigger reportedsize, which triggers this observable, too
    # we only need to know here if there are relative sizes given, because
    # those can only be computed knowing the suggestedbbox
    widthattr, heightattr = sizeattrs[]
    T = eltype(protrusions)

    cwidth, cheight = reporteddimensions.inner
    w_target = T(if isnothing(cwidth)
        if widthattr isa Relative
            widthattr.x * bw
        elseif widthattr isa Nothing
            bw
        elseif widthattr isa Auto
            if isnothing(autosizeobservable[][1])
                # we have no autowidth available anyway
                # take suggested width
                bw
            else
                # use the width that was auto-computed
                autosizeobservable[][1]
            end
        elseif widthattr isa Fixed
            widthattr.x
        elseif widthattr isa Real
            Float32(widthattr)
        else
            error("Unknown width attribute $widthattr")
        end
    else
        cwidth
    end)::T

    h_target = T(if isnothing(cheight)
        if heightattr isa Relative
            heightattr.x * bh
        elseif heightattr isa Nothing
            bh
        elseif heightattr isa Auto
            if isnothing(autosizeobservable[][2])
                # we have no autoheight available anyway
                # take suggested height
                bh
            else
                # use the height that was auto-computed
                autosizeobservable[][2]
            end
        elseif heightattr isa Fixed
            heightattr.x
        elseif heightattr isa Real
            Float32(heightattr)
        else
            error("Unknown height attribute $heightattr")
        end
    else
        cheight
    end)::T

    inner_w, inner_h = if alignmode isa Inside
        (w_target, h_target)
    elseif alignmode isa Outside
        (w_target - protrusions.left - protrusions.right - alignmode.padding.left - alignmode.padding.right,
            h_target - protrusions.top - protrusions.bottom - alignmode.padding.top - alignmode.padding.bottom)
    else
        alignmode = alignmode::Mixed
        let
            w = w_target
            # subtract if outside padding is used via a Float32 value
            # Protrusion and `nothing` are protrusion modes
            if alignmode.sides.left isa Float32
                w -= protrusions.left + alignmode.sides.left
            end
            if alignmode.sides.right isa Float32
                w -= protrusions.right + alignmode.sides.right
            end

            h = h_target
            if alignmode.sides.bottom isa Float32
                h -= protrusions.bottom + alignmode.sides.bottom
            end
            if alignmode.sides.top isa Float32
                h -= protrusions.top + alignmode.sides.top
            end

            w, h
        end
    end

    # how much space is left in the bounding box
    rw = bw - w_target
    rh = bh - h_target

    xshift, yshift = alignment .* (rw, rh)

    if alignmode isa Inside
        # width and height are unaffected
    elseif alignmode isa Outside
        xshift = xshift + protrusions.left + alignmode.padding.left
        yshift = yshift + protrusions.bottom + alignmode.padding.bottom
    else
        am = alignmode::Mixed
        if am.sides.left isa Float32
            xshift += protrusions.left + am.sides.left
        end
        if am.sides.bottom isa Float32
            yshift += protrusions.bottom + am.sides.bottom
        end
    end

    # align the final bounding box in the layout bounding box
    l = left(suggestedbbox) + xshift
    b = bottom(suggestedbbox) + yshift
    r = l + inner_w
    t = b + inner_h
    newbbox = BBox(l, r, b, t)
    # if computedbbox[] != newbbox
    #     computedbbox[] = newbbox
    # end
    computedbbox[] = newbbox

    return
end

"""
    layoutobservables(x::T) where T

Access `x`'s field `:layoutobservables` containing a `LayoutObservables` instance. This should
be overloaded for any type that is layoutable but stores its `LayoutObservables` in
a differently named field.
"""
function layoutobservables(x::T)::LayoutObservables{GridLayout} where T
    if hasfield(T, :layoutobservables) && fieldtype(T, :layoutobservables) === LayoutObservables{GridLayout}
        x.layoutobservables
    else
        error("It's not defined how to get LayoutObservables for type $T, overload this method for layoutable types.")
    end
end

# These are the default API functions to retrieve the layout parts from an object
protrusionsobservable(x) = layoutobservables(x).protrusions
suggestedbboxobservable(x) = layoutobservables(x).suggestedbbox
reporteddimensionsobservable(x) = layoutobservables(x).reporteddimensions
autosizeobservable(x) = layoutobservables(x).autosize
computedbboxobservable(x) = layoutobservables(x).computedbbox
gridcontent(x) = layoutobservables(x).gridcontent[]

"""
    GridLayout(; kwargs...)

Create a `GridLayout` without parent and with size [1, 1].
"""
GridLayout(; kwargs...) = GridLayout(1, 1; kwargs...)

"""
    GridLayout(g::Union{GridPosition, GridSubposition}, args...; kwargs...)

Create a `GridLayout` at position `g` in the parent `GridLayout` of `g` if it is a `GridPosition`
and in a nested child `GridLayout` if it is a `GridSubposition`. The `args` and `kwargs` are passed on to the normal `GridLayout` constructor.
"""
function GridLayout(g::Union{GridPosition, GridSubposition}, args...; kwargs...)
    return g[] = GridLayout(args...; kwargs...)
end

observablify(x::Observable) = x
observablify(x, type=Any) = Observable{type}(x)

get_default_rowgap()::Float64 = DEFAULT_ROWGAP_GETTER[]()
get_default_colgap()::Float64 = DEFAULT_COLGAP_GETTER[]()

Base.convert(::Type{T}, a::Real) where T <: Union{HorizontalAlignment, VerticalAlignment} = T(a)
function Base.convert(::Type{HorizontalAlignment}, s::Symbol)
    if s === :left
        HorizontalAlignment(0.0)
    elseif s === :right
        HorizontalAlignment(1.0)
    elseif s === :center
        HorizontalAlignment(0.5)
    else
        error("Symbol $s is not a horizontal alignment. Possible values are :left, :right, :center.")
    end
end
function Base.convert(::Type{VerticalAlignment}, s::Symbol)
    if s === :bottom
        VerticalAlignment(0.0)
    elseif s === :top
        VerticalAlignment(1.0)
    elseif s === :center
        VerticalAlignment(0.5)
    else
        error("Symbol $s is not a vertical alignment. Possible values are :bottom, :top, :center.")
    end
end

# maybe this is not ideal, converting to an abstract type?
Base.convert(::Type{SizeAttribute}, r::Real) = Float32(r)
Base.convert(::Type{SizeAttribute}, f::Fixed) = f
Base.convert(::Type{SizeAttribute}, r::Relative) = r
Base.convert(::Type{SizeAttribute}, a::Auto) = a

@inline function Base.setproperty!(g::GridLayout, s::Symbol, value)
    T = fieldtype(GridLayout, s)
    if T <: Observable
        setindex!(getfield(g, s), value)
    else
        setfield!(g, s, convert(T, value))
    end
end

"""
    function GridLayout(nrows::Integer, ncols::Integer;
        parent = nothing,
        rowsizes = nothing,
        colsizes = nothing,
        addedrowgaps = nothing,
        addedcolgaps = nothing,
        alignmode = Inside(),
        equalprotrusiongaps = (false, false),
        bbox = nothing,
        width = Auto(),
        height = Auto(),
        tellwidth::Bool = true,
        tellheight::Bool = true,
        halign = :center,
        valign = :center,
        default_rowgap = get_default_rowgap(),
        default_colgap = get_default_colgap(),
        kwargs...)

Create a `GridLayout` with optional parent `parent` with `nrows` rows and `ncols` columns.
"""
function GridLayout(nrows::Integer, ncols::Integer;
        parent = nothing,
        rowsizes = nothing,
        colsizes = nothing,
        addedrowgaps = nothing,
        addedcolgaps = nothing,
        alignmode = Inside(),
        equalprotrusiongaps = (false, false),
        bbox = nothing,
        width = Auto(),
        height = Auto(),
        tellwidth::Bool = true,
        tellheight::Bool = true,
        halign = :center,
        valign = :center,
        default_rowgap = get_default_rowgap(),
        default_colgap = get_default_colgap(),
        kwargs...)

    default_rowgap::GapSize = default_rowgap isa Number ? Fixed(default_rowgap)::Fixed : default_rowgap
    default_colgap::GapSize = default_colgap isa Number ? Fixed(default_colgap)::Fixed : default_colgap
    rowsizes = convert_contentsizes(nrows, rowsizes)
    colsizes = convert_contentsizes(ncols, colsizes)
    addedrowgaps = convert_gapsizes(nrows - 1, addedrowgaps, default_rowgap)
    addedcolgaps = convert_gapsizes(ncols - 1, addedcolgaps, default_colgap)

    content = GridContent[]

    alignmode = observablify(alignmode, AlignMode)
    width_obs = convert(Observable{SizeAttribute}, width)
    height_obs = convert(Observable{SizeAttribute}, height)
    tellwidth_obs = convert(Observable{Bool}, tellwidth)
    tellheight_obs = convert(Observable{Bool}, tellheight)
    halign_obs = convert(Observable{HorizontalAlignment}, halign)
    valign_obs = convert(Observable{VerticalAlignment}, valign)

    layoutobservables = layoutobservables = LayoutObservables(
        width_obs,
        height_obs,
        tellwidth_obs,
        tellheight_obs,
        halign_obs,
        valign_obs;
        suggestedbbox = bbox
    )

    offsets = (0, 0)

    gl = GridLayout(
        parent,
        content,
        (nrows, ncols),
        offsets,
        rowsizes,
        colsizes,
        addedrowgaps,
        addedcolgaps,
        alignmode,
        equalprotrusiongaps,
        layoutobservables,
        width_obs,
        height_obs,
        tellwidth_obs,
        tellheight_obs,
        halign_obs,
        valign_obs,
        default_rowgap,
        default_colgap
    )
    on(computedbboxobservable(gl)) do bbox
        # block_updates can block update! but not setting computedbbox directly through protrusions/etc
        # so this one needs to be blocked as well
        if !gl.block_updates
            align_to_bbox!(gl, bbox)
        end
    end
    gl
end

function update!(gl::GridLayout)
    gl.block_updates && return

    w = determinedirsize(gl, Col())
    h = determinedirsize(gl, Row())

    new_autosize = (w, h)
    new_protrusions = RectSides{Float32}(
        compute_effective_protrusion(gl, Left()),
        compute_effective_protrusion(gl, Right()),
        compute_effective_protrusion(gl, Bottom()),
        compute_effective_protrusion(gl, Top()),
    )

    # if autosize and protrusions didn't change, then we only need to trigger a relayout in this gridlayout
    # but don't retrigger autosize and protrusions which would go up to a possible parent gridlayout

    gc = gridcontent(gl)

    # TODO: if we skip this because protrusions/autosize are unchanged, we get update failures when adding new objects that don't change these values to a gridlayout
    if gc === nothing
        # no parent exists, so protrusions/autosize will trigger computedbbox, which will trigger relayout
        bu = gl.block_updates
        # this will prohibit align_to_bbox! triggering from computedbbox
        gl.block_updates = true
        protrusionsobservable(gl)[] = new_protrusions
        autosizeobservable(gl)[] = new_autosize
        gl.block_updates = bu
        # now we trigger computedbbox ourselves which will call align_to_bbox! and relayout children
        notify(computedbboxobservable(gl))
    else
        # parent exists, so protrusions/autosize will not trigger computedbbox
        # don't update parent by setting protrusions / autosize
        layoutobservables(gl).block_updates[] = true

        protrusionsobservable(gl)[] = new_protrusions
        autosizeobservable(gl)[] = new_autosize

        layoutobservables(gl).block_updates[] = false
        # update parent manually
        update!(gc)
    end

    return
end

function validategridlayout(gl::GridLayout)
    if nrows(gl) < 1
        error("Number of rows can't be smaller than 1")
    end
    if ncols(gl) < 1
        error("Number of columns can't be smaller than 1")
    end

    if length(gl.rowsizes) != nrows(gl)
        error("There are $nrows rows but $(length(gl.rowsizes)) row sizes.")
    end
    if length(gl.colsizes) != ncols(gl)
        error("There are $ncols columns but $(length(gl.colsizes)) column sizes.")
    end
    if length(gl.addedrowgaps) != nrows(gl) - 1
        error("There are $nrows rows but $(length(gl.addedrowgaps)) row gaps.")
    end
    if length(gl.addedcolgaps) != ncols(gl) - 1
        error("There are $ncols columns but $(length(gl.addedcolgaps)) column gaps.")
    end
end

"""
    with_updates_suspended(f::Function, gl::GridLayout; update = true)

Disable layout updates for `gl` and call the function `f`. If `update` is true,
force a layout update after `f` returns.
"""
function with_updates_suspended(f::Function, gl::GridLayout; update = true)
    prev_block_value = gl.block_updates
    gl.block_updates = true
    f()
    gl.block_updates = prev_block_value
    if update
        update!(gl)
    end
    return
end

function connect_layoutobservables!(gc::GridContent)

    disconnect_layoutobservables!(gc::GridContent)

    let content = gc.content
        # gc.protrusions_handle = on(effectiveprotrusionsobservable(content)) do p
        #     if !layoutobservables(content).block_updates[]::Bool
        #         update!(gc)
        #     end
        # end
        gc.reportedsize_handle = on(reporteddimensionsobservable(content)) do c
            if !layoutobservables(content).block_updates[]::Bool
                update!(gc)
            end
        end
    end
end

function disconnect_layoutobservables!(gc::GridContent)
    # if !isnothing(gc.protrusions_handle)
    #     Observables.off(effectiveprotrusionsobservable(gc.content), gc.protrusions_handle)
    #     gc.protrusions_handle = nothing
    # end
    if !isnothing(gc.reportedsize_handle)
        Observables.off(reporteddimensionsobservable(gc.content), gc.reportedsize_handle)
        gc.reportedsize_handle = nothing
    end
end

function add_to_gridlayout!(g::GridLayout, gc::GridContent)
    # to be safe
    remove_from_gridlayout!(gc)

    push!(g.content, gc)

    # let the gridcontent know that it's inside a gridlayout
    gc.parent = g
    # change the parent if the gridcontent contains a gridlayout
    content = gc.content
    if content isa GridLayout
        content.parent = g
    end

    # trigger relayout
    update!(g)
end


function remove_from_gridlayout!(gc::GridContent)
    content = gc.content
    if isnothing(gc.parent)
        if content isa GridLayout
            content.parent = nothing
        end
        return
    end

    i = findfirst(x -> x === gc, gc.parent.content)
    if isnothing(i)
        error("""GridContent had a parent but was not in the content array.
        This must be a bug.""")
    end
    deleteat!(gc.parent.content, i)

    gc.parent = nothing
    # set the parent of a gridlayout content to nothing separately
    # this is mostly for one toplevel parent like a Figure in Makie
    if content isa GridLayout
        content.parent = nothing
    end

    return
end


function convert_contentsizes(n, sizes)::Vector{ContentSize}
    if sizes === nothing
        ContentSize[Auto() for _ in 1:n]
    elseif sizes isa ContentSize
        ContentSize[sizes for _ in 1:n]
    elseif sizes isa Vector{<:ContentSize}
        length(sizes) == n ? sizes : error("$(length(sizes)) sizes instead of $n")
    else
        error("Illegal sizes value $sizes")
    end
end

function convert_gapsizes(n, gaps, defaultsize)::Vector{GapSize}
    if gaps === nothing
        GapSize[defaultsize for _ in 1:n]
    elseif gaps isa GapSize
        GapSize[gaps for _ in 1:n]
    elseif gaps isa Vector{<:GapSize}
        length(gaps) == n ? gaps : error("$(length(gaps)) gaps instead of $n")
    else
        error("Illegal gaps value $gaps")
    end
end

function appendrows!(gl::GridLayout, n::Integer; rowsizes=nothing, addedrowgaps=nothing, update = true)

    rowsizes = convert_contentsizes(n, rowsizes)
    addedrowgaps = convert_gapsizes(n, addedrowgaps, gl.default_rowgap)

    with_updates_suspended(gl, update = update) do
        set_nrows!(gl, nrows(gl) + n)
        append!(gl.rowsizes, rowsizes)
        append!(gl.addedrowgaps, addedrowgaps)
    end
end

function appendcols!(gl::GridLayout, n::Integer; colsizes=nothing, addedcolgaps=nothing, update = true)
    colsizes = convert_contentsizes(n, colsizes)
    addedcolgaps = convert_gapsizes(n, addedcolgaps, gl.default_colgap)

    with_updates_suspended(gl, update = update) do
        set_ncols!(gl, ncols(gl) + n)
        append!(gl.colsizes, colsizes)
        append!(gl.addedcolgaps, addedcolgaps)
    end
end

function prependrows!(gl::GridLayout, n::Integer; rowsizes=nothing, addedrowgaps=nothing, update = true)

    rowsizes = convert_contentsizes(n, rowsizes)
    addedrowgaps = convert_gapsizes(n, addedrowgaps, gl.default_rowgap)

    with_updates_suspended(gl, update = update) do
        set_nrows!(gl, nrows(gl) + n)
        set_rowoffset!(gl, offset(gl, Row()) - n)
        prepend!(gl.rowsizes, rowsizes)
        prepend!(gl.addedrowgaps, addedrowgaps)
    end
end

function prependcols!(gl::GridLayout, n::Integer; colsizes=nothing, addedcolgaps=nothing, update = true)

    colsizes = convert_contentsizes(n, colsizes)
    addedcolgaps = convert_gapsizes(n, addedcolgaps, gl.default_colgap)

    with_updates_suspended(gl, update = update) do
        set_ncols!(gl, ncols(gl) + n)
        set_coloffset!(gl, offset(gl, Col()) - n)
        prepend!(gl.colsizes, colsizes)
        prepend!(gl.addedcolgaps, addedcolgaps)
    end
end


"""
    insertrows!(gl::GridLayout, at::Integer, n::Integer; rowsizes=nothing, addedrowgaps=nothing)

Insert `n` rows at row `at` into `GridLayout` `gl`. The new row sizes and row gaps can be
optionally set with `rowsizes` and `addedrowgaps` keywords.
Objects spanning from at least `at-1` up to or beyond `at` are getting extended to span
over the new rows. Objects from `at` and beyond are pushed back, objects before `at` are
unaffected.
"""
function insertrows!(gl::GridLayout, at::Integer, n::Integer; rowsizes=nothing, addedrowgaps=nothing)

    if !(1 <= at <= nrows(gl))
        error("Invalid row insertion at row $at. GridLayout has $(nrows(gl)) rows.")
    end

    rowsizes = convert_contentsizes(n, rowsizes)
    addedrowgaps = convert_gapsizes(n, addedrowgaps, gl.default_rowgap)

    foreach(gl.content) do gc
        span = gc.span
        rows = span.rows
        newrows = if rows.start < at <= rows.stop
            rows.start : rows.stop + n
        elseif rows.stop < at
            rows
        elseif rows.start >= at
            rows .+ n
        end
        newspan = Span(newrows, span.cols)
        gc.span = newspan
    end

    with_updates_suspended(gl) do
        set_nrows!(gl, nrows(gl) + n)
        splice!(gl.rowsizes, at:at-1, rowsizes)
        splice!(gl.addedrowgaps, at:at-1, addedrowgaps)
    end
end

"""
    insertcols!(gl::GridLayout, at::Integer, n::Integer; colsizes=nothing, addedcolgaps=nothing)

Insert `n` columns at column `at` into `GridLayout` `gl`. The new column sizes and column gaps can be
optionally set with `colsizes` and `addedcolgaps` keywords.
Objects spanning from at least `at-1` up to or beyond `at` are getting extended to span
over the new columns. Objects from `at` and beyond are pushed back, objects before `at` are
unaffected.
"""
function insertcols!(gl::GridLayout, at::Integer, n::Integer; colsizes=nothing, addedcolgaps=nothing)

    if !(1 <= at <= ncols(gl))
        error("Invalid column insertion at column $at. GridLayout has $(ncols(gl)) columns.")
    end

    colsizes = convert_contentsizes(n, colsizes)
    addedcolgaps = convert_gapsizes(n, addedcolgaps, gl.default_colgap)

    foreach(gl.content) do gc
        span = gc.span
        cols = span.cols
        newcols = if cols.start < at <= cols.stop
            cols.start : cols.stop + n
        elseif cols.stop < at
            cols
        elseif cols.start >= at
            cols .+ n
        end
        newspan = Span(span.rows, newcols)
        gc.span = newspan
    end

    with_updates_suspended(gl) do
        set_ncols!(gl, ncols(gl) + n)
        splice!(gl.colsizes, at:at-1, colsizes)
        splice!(gl.addedcolgaps, at:at-1, addedcolgaps)
    end
end

function deleterow!(gl::GridLayout, irow::Integer)
    if !(firstrow(gl) <= irow <= lastrow(gl))
        error("Row $irow does not exist.")
    end

    if nrows(gl) == 1
        error("Can't delete the only row.")
    end

    # new_content = GridContent[]
    to_remove = GridContent[]
    for c in gl.content
        rows = c.span.rows
        newrows = if irow in rows
            # range is one shorter now
            rows.start : rows.stop - 1
        elseif irow > rows.stop
            # content before deleted row stays the same
            rows
        else
            # content completely after is moved forward 1 step
            rows .- 1
        end
        if isempty(newrows)
            # the row span was just one row and now zero, remove the element
            push!(to_remove, c)
        else
            c.span = Span(newrows, c.span.cols)
        end
    end

    for c in to_remove
        remove_from_gridlayout!(c)
    end

    idx = irow - rowoffset(gl)
    deleteat!(gl.rowsizes, idx)
    deleteat!(gl.addedrowgaps, idx == 1 ? 1 : idx - 1)
    set_nrows!(gl, nrows(gl) - 1)
    update!(gl)
end

rowoffset(gl) = offset(gl, Row())
coloffset(gl) = offset(gl, Col())

function deletecol!(gl::GridLayout, icol::Integer)
    if !(firstcol(gl) <= icol <= lastcol(gl))
        error("Col $icol does not exist.")
    end

    if ncols(gl) == 1
        error("Can't delete the only column.")
    end

    to_remove = GridContent[]
    for c in gl.content
        cols = c.span.cols
        newcols = if icol in cols
            # range is one shorter now
            cols.start : cols.stop - 1
        elseif icol > cols.stop
            # content before deleted col stays the same
            cols
        else
            # content completely after is moved forward 1 step
            cols .- 1
        end
        if isempty(newcols)
            # the col span was just one col and now zero, remove the element
            push!(to_remove, c)
        else
            c.span = Span(c.span.rows, newcols)
        end
    end

    for c in to_remove
        remove_from_gridlayout!(c)
    end

    idx = icol - coloffset(gl)
    deleteat!(gl.colsizes, idx)
    deleteat!(gl.addedcolgaps, idx == 1 ? 1 : idx - 1)
    set_ncols!(gl, ncols(gl) - 1)
    update!(gl)
end

function Base.isempty(gl::GridLayout, dir::GridDir, i::Integer)
    !any(gl.content) do c
        span = dir isa Row ? c.span.rows : c.span.cols
        i in span
    end
end

"""
    trim!(gl::GridLayout)

Remove empty rows and columns from `gl`.
"""
function trim!(gl::GridLayout)
    irow = firstrow(gl)
    while irow <= lastrow(gl) && nrows(gl) > 1
        if isempty(gl, Row(), irow)
            deleterow!(gl, irow)
        else
            irow += 1
        end
    end

    icol = firstcol(gl)
    while icol <= lastcol(gl) && ncols(gl) > 1
        if isempty(gl, Col(), icol)
            deletecol!(gl, icol)
        else
            icol += 1
        end
    end
end

function gridnest!(gl::GridLayout, rows::Indexables, cols::Indexables)

    newrows, newcols = adjust_rows_cols!(gl, rows, cols)

    subgl = GridLayout(
        length(newrows), length(newcols);
        parent = nothing,
        colsizes = gl.colsizes[newcols],
        rowsizes = gl.rowsizes[newrows],
        addedrowgaps = gl.addedrowgaps[newrows.start:(newrows.stop-1)],
        addedcolgaps = gl.addedcolgaps[newcols.start:(newcols.stop-1)],
    )

    # remove the content from the parent that is completely inside the replacement grid
    subgl.block_updates = true
    i = 1
    while i <= length(gl.content)
        gc = gl.content[i]

        if (gc.span.rows.start >= newrows.start && gc.span.rows.stop <= newrows.stop &&
            gc.span.cols.start >= newcols.start && gc.span.cols.stop <= newcols.stop)


            subgl[gc.span.rows .- (newrows.start - 1), gc.span.cols .- (newcols.start - 1), gc.side] = gc.content
            continue
            # don't advance i because there's one piece of content less in the queue
            # and the next item is in the same position as the old removed one
        end
        i += 1
    end
    subgl.block_updates = false

    gl[newrows, newcols] = subgl

    subgl
end


function Base.show(io::IO, ::MIME"text/plain", gl::GridLayout)

    function spaceindent(str, n, downconnection)
        joinstr = if downconnection
            "\n" * (" " ^ 1) * "┃" * (" " ^ (n-2))
        else
            "\n" * (" " ^ n)
        end
        join(split(str, "\n"), joinstr)
    end

    rowrange = firstrow(gl):lastrow(gl)
    colrange = firstcol(gl):lastcol(gl)

    println(io, "GridLayout[$rowrange, $colrange] with $(length(gl.content)) children")

    simplespan(span) = span.start == span.stop ? span.start : span

    for (i, c) in enumerate(gl.content)
        rows = c.span.rows
        cols = c.span.cols
        content = c.content

        connector = i == length(gl.content) ? " ┗━ " : " ┣━ "

        if content isa GridLayout
            downconnection = i < length(gl.content)
            str = spaceindent(repr(MIME"text/plain"(), content), 2, downconnection)
            println(io, connector * "[$(simplespan(rows)), $(simplespan(cols))] $str")
        else
            println(io, connector * "[$(simplespan(rows)), $(simplespan(cols))] $(typeof(content))")
        end
    end
end

function Base.show(io::IO, gl::GridLayout)
    print(io, "GridLayout[$(nrows(gl)), $(ncols(gl))] ($(length(gl.content)) children)")
end


"""
    colsize!(gl::GridLayout, i::Integer, s::Union{Aspect, Auto, Fixed, Relative, Real})

Set the size of the `i`th column in `gl`, i.e., `gl[:, i]`.
Passing a real number to `s` has the same behaviour as passing `Fixed(s)`.

See also [Aspect](@ref), [Auto](@ref), [Fixed](@ref), and [Relative](@ref).
"""
function colsize!(gl::GridLayout, i::Integer, s::ContentSize)
    if !(firstcol(gl) <= i <= lastcol(gl))
        error("Can't set size of invalid column $i.")
    end
    i_unoffset = unoffset(gl, i, Col())
    gl.colsizes[i_unoffset] = s
    update!(gl)
end

colsize!(gl::GridLayout, i::Integer, s::Real) = colsize!(gl, i, Fixed(s))

"""
    rowsize!(gl::GridLayout, i::Integer, s::Union{Aspect, Auto, Fixed, Relative, Real})

Set the size of the `i`th row in `gl`, i.e., `gl[i, :]`.
Passing a real number to `s` has the same behaviour as passing `Fixed(s)`.

See also [Aspect](@ref), [Auto](@ref), [Fixed](@ref), and [Relative](@ref).
"""
function rowsize!(gl::GridLayout, i::Integer, s::ContentSize)
    if !(firstrow(gl) <= i <= lastrow(gl))
        error("Can't set size of invalid row $i.")
    end
    i_unoffset = unoffset(gl, i, Row())
    gl.rowsizes[i_unoffset] = s
    update!(gl)
end

rowsize!(gl::GridLayout, i::Integer, s::Real) = rowsize!(gl, i, Fixed(s))

"""
    colgap!(gl::GridLayout, i::Integer, s::Union{Fixed, Relative, Real})
    colgap!(gl::GridLayout, s::Union{Fixed, Relative, Real})

Set the gap between columns in `gl`.  The two-argument version sets all column gaps
in `gl`.  The three-argument version sets the gap between columns `i` and `i+1`.
Passing a real number to `s` has the same behaviour as passing `Fixed(s)`.

See also [Fixed](@ref) and [Relative](@ref).
"""
function colgap!(gl::GridLayout, i::Integer, s::GapSize)
    if !(1 <= i <= (ncols(gl) - 1))
        error("Can't set size of invalid column gap $i.")
    end
    gl.addedcolgaps[i] = s
    update!(gl)
end

colgap!(gl::GridLayout, i::Integer, s::Real) = colgap!(gl, i, Fixed(s))

function colgap!(gl::GridLayout, s::GapSize)
    gl.addedcolgaps .= Ref(s)
    update!(gl)
end

function colgap!(gl::GridLayout, r::Real)
    gl.addedcolgaps .= Ref(Fixed(r))
    update!(gl)
end

"""
    rowgap!(gl::GridLayout, i::Integer, s::Union{Fixed, Relative, Real})
    rowgap!(gl::GridLayout, s::Union{Fixed, Relative, Real})

Set the gap between rows in `gl`.  The two-argument version sets all row gaps
in `gl`.  The three-argument version sets the gap between rows `i` and `i+1`.
Passing a real number to `s` has the same behaviour as passing `Fixed(s)`.

See also [Fixed](@ref) and [Relative](@ref).
"""
function rowgap!(gl::GridLayout, i::Integer, s::GapSize)
    if !(1 <= i <= (nrows(gl) - 1))
        error("Can't set size of invalid row gap $i.")
    end
    gl.addedrowgaps[i] = s
    update!(gl)
end

rowgap!(gl::GridLayout, i::Integer, s::Real) = rowgap!(gl, i, Fixed(s))

function rowgap!(gl::GridLayout, s::GapSize)
    gl.addedrowgaps .= Ref(s)
    update!(gl)
end

function rowgap!(gl::GridLayout, r::Real)
    gl.addedrowgaps .= Ref(Fixed(r))
    update!(gl)
end


function _compute_content_bbox(suggestedbbox, alignmode::Outside)
    pad = alignmode.padding
    BBox(
        left(suggestedbbox) + pad.left,
        right(suggestedbbox) - pad.right,
        bottom(suggestedbbox) + pad.bottom,
        top(suggestedbbox) - pad.top)
end

function _compute_content_bbox(suggestedbbox, ::Inside)
    suggestedbbox
end

function _compute_content_bbox(suggestedbbox, alignmode::Mixed)
    sides = alignmode.sides
    BBox(
        left(suggestedbbox) + (sides.left isa Float32 ? sides.left : 0f0),
        right(suggestedbbox) - (sides.right isa Float32 ? sides.right : 0f0),
        bottom(suggestedbbox) + (sides.bottom isa Float32 ? sides.bottom : 0f0),
        top(suggestedbbox) - (sides.top isa Float32 ? sides.top : 0f0))
end

# compute a grid of maximum protrusions for a gridlayout
function _compute_maxgrid(gl)
    maxgrid = RowCols(ncols(gl), nrows(gl))
    for c in gl.content
        # TODO this RowCols{Int} should actually just be a RectSides and RowCols should always store vectors
        idx_rect = side_indices(gl, c)
        mapsides(idx_rect, maxgrid) do side, idx, grid
            grid[idx] = max(grid[idx], effective_protrusion(c, side, c.side)::Float32)
        end
    end
    maxgrid
end

effective_protrusion(c::GridContent, ::Left) = reporteddimensionsobservable(c.content)[].outer.left
effective_protrusion(c::GridContent, ::Right) = reporteddimensionsobservable(c.content)[].outer.right
effective_protrusion(c::GridContent, ::Top) = reporteddimensionsobservable(c.content)[].outer.top
effective_protrusion(c::GridContent, ::Bottom) = reporteddimensionsobservable(c.content)[].outer.bottom

effective_protrusion(c::GridContent, ::Left, ::Inner) = reporteddimensionsobservable(c.content)[].outer.left
effective_protrusion(c::GridContent, ::Right, ::Inner) = reporteddimensionsobservable(c.content)[].outer.right
effective_protrusion(c::GridContent, ::Top, ::Inner) = reporteddimensionsobservable(c.content)[].outer.top
effective_protrusion(c::GridContent, ::Bottom, ::Inner) = reporteddimensionsobservable(c.content)[].outer.bottom

effective_protrusion(c::GridContent, ::Left, s::Union{Left, BottomLeft, TopLeft}) = something(determinedirsize(c, Col(), s), 0f0)
effective_protrusion(c::GridContent, ::Right, s::Union{Right, BottomRight, TopRight}) = something(determinedirsize(c, Col(), s), 0f0)
effective_protrusion(c::GridContent, ::Bottom, s::Union{Bottom, BottomRight, BottomLeft}) = something(determinedirsize(c, Row(), s), 0f0)
effective_protrusion(c::GridContent, ::Top, s::Union{Top, TopRight, TopLeft}) = something(determinedirsize(c, Row(), s), 0f0)
effective_protrusion(c::GridContent, _, _) = 0f0

sideoffset(gl, ::Union{Right, Left}) = offset(gl, Col())
sideoffset(gl, ::Union{Top, Bottom}) = offset(gl, Row())

function _compute_remaining_horizontal_space(content_bbox, sumcolgaps, leftprot, rightprot, alignmode::Inside)::Float32
    width(content_bbox) - sumcolgaps
end

function _compute_remaining_horizontal_space(content_bbox, sumcolgaps, leftprot, rightprot, alignmode::Outside)::Float32

    width(content_bbox) - sumcolgaps - leftprot - rightprot
end

function _compute_remaining_horizontal_space(content_bbox, sumcolgaps, leftprot, rightprot, alignmode::Mixed)::Float32

    rightal = getside(alignmode, Right())
    leftal = getside(alignmode, Left())
    width(content_bbox) - sumcolgaps -
        (isnothing(leftal) ? zero(leftprot) : isa(leftal, Protrusion) ? leftal.p : leftprot) -
        (isnothing(rightal) ? zero(rightprot) : isa(rightal, Protrusion) ? rightal.p : rightprot)
end

function _compute_remaining_vertical_space(content_bbox, sumrowgaps, topprot, bottomprot, alignmode::Inside)::Float32

    height(content_bbox) - sumrowgaps
end

function _compute_remaining_vertical_space(content_bbox, sumrowgaps, topprot, bottomprot, alignmode::Outside)::Float32

    height(content_bbox) - sumrowgaps - topprot - bottomprot
end

function _compute_remaining_vertical_space(content_bbox, sumrowgaps, topprot, bottomprot, alignmode::Mixed)::Float32

    topal = getside(alignmode, Top())
    bottomal = getside(alignmode, Bottom())
    height(content_bbox) - sumrowgaps -
        (isnothing(bottomal) ? zero(bottomprot) : isa(bottomal, Protrusion) ? bottomal.p : bottomprot) -
        (isnothing(topal) ? zero(topprot) : isa(topal, Protrusion) ? topal.p : topprot)
end

"""
This function solves a grid layout such that the "important lines" fit exactly
into a given bounding box. This means that the protrusions of all objects inside
the grid are not taken into account. This is needed if the grid is itself placed
inside another grid.
"""
function compute_rowcols(gl::GridLayout, suggestedbbox::Rect2f)
    # compute the actual bbox for the content given that there might be outside
    # padding that needs to be removed
    alignmode = gl.alignmode[]
    content_bbox = _compute_content_bbox(suggestedbbox, alignmode)

    # first determine how big the protrusions on each side of all columns and rows are
    maxgrid = _compute_maxgrid(gl)

    # for the outside alignmode
    topprot = maxgrid.tops[1]
    bottomprot = maxgrid.bottoms[end]
    leftprot = maxgrid.lefts[1]
    rightprot = maxgrid.rights[end]

    # compute what size the gaps between rows and columns need to be
    colgaps = maxgrid.lefts[2:end] .+ maxgrid.rights[1:end-1]
    rowgaps = maxgrid.tops[2:end] .+ maxgrid.bottoms[1:end-1]

    # determine the biggest gap
    # using the biggest gap size for all gaps will make the layout more even
    if gl.equalprotrusiongaps[2]
        colgaps = ncols(gl) <= 1 ? [0f0] : fill(maximum(colgaps), ncols(gl) - 1)
    end
    if gl.equalprotrusiongaps[1]
        rowgaps = nrows(gl) <= 1 ? [0f0] : fill(maximum(rowgaps), nrows(gl) - 1)
    end

    # determine the vertical and horizontal space needed just for the gaps
    # again, the gaps are what the protrusions stick into, so they are not actually "empty"
    # depending on what sticks out of the plots
    sumcolgaps = (ncols(gl) <= 1) ? 0f0 : sum(colgaps)
    sumrowgaps = (nrows(gl) <= 1) ? 0f0 : sum(rowgaps)

    # compute what space remains for the inner parts of the plots
    remaininghorizontalspace = _compute_remaining_horizontal_space(content_bbox, sumcolgaps, leftprot, rightprot, alignmode)

    remainingverticalspace = _compute_remaining_vertical_space(content_bbox, sumrowgaps, topprot, bottomprot, alignmode)

    # compute how much gap to add, in case e.g. labels are too close together
    # this is given as a fraction of the space used for the inner parts of the plots
    # so far, but maybe this should just be an absolute pixel value so it doesn't change
    # when resizing the window
    addedcolgaps::Vector{Float32} = map(gl.addedcolgaps) do cg
        if cg isa Fixed
            return cg.x
        elseif cg isa Relative
            return cg.x * remaininghorizontalspace
        else
            return 0f0 # for float type inference
        end
    end
    addedrowgaps::Vector{Float32} = map(gl.addedrowgaps) do rg
        if rg isa Fixed
            return rg.x
        elseif rg isa Relative
            return rg.x * remainingverticalspace
        else
            return 0f0 # for float type inference
        end
    end

    # compute the actual space available for the rows and columns (plots without protrusions)
    spaceforcolumns = remaininghorizontalspace - ((ncols(gl) <= 1) ? 0f0 : sum(addedcolgaps))
    spaceforrows = remainingverticalspace - ((nrows(gl) <= 1) ? 0f0 : sum(addedrowgaps))

    colwidths, rowheights = compute_col_row_sizes(spaceforcolumns, spaceforrows, gl)

    # don't allow smaller widths than 1 px even if it breaks the layout (better than weird glitches)
    colwidths = max.(colwidths, 1f0)
    rowheights = max.(rowheights, 1f0)

    # this is the vertical / horizontal space between the inner lines of all plots
    finalcolgaps = colgaps .+ addedcolgaps
    finalrowgaps = rowgaps .+ addedrowgaps

    # compute the resulting width and height of the gridlayout and compute
    # adjustments for the grid's alignment (this will only matter if the grid is
    # bigger or smaller than the bounding box it occupies)

    gridwidth = sum(colwidths) + sum(finalcolgaps) +
        if alignmode isa Outside
            leftprot + rightprot
        elseif alignmode isa Mixed
            rightal = getside(alignmode, Right())
            leftal = getside(alignmode, Left())
            r = if rightal === nothing
                0f0
            elseif rightal isa Protrusion
                rightal.p
            elseif rightal isa Real
                rightprot
            end
            l = if leftal === nothing
                0f0
            elseif leftal isa Protrusion
                leftal.p
            elseif leftal isa Real
                leftprot
                leftprot
            end
            r + l
        else
            0f0
        end

    gridheight = sum(rowheights) + sum(finalrowgaps) +
        if alignmode isa Outside
            topprot + bottomprot
        elseif alignmode isa Mixed
            bottomal = getside(alignmode, Bottom())
            topal = getside(alignmode, Top())
            b = if bottomal === nothing
                0f0
            elseif bottomal isa Protrusion
                bottomal.p
            elseif bottomal isa Real
                Float32(bottomprot)
            end
            t = if topal === nothing
                0f0
            elseif topal isa Protrusion
                topal.p
            elseif topal isa Real
                Float32(topprot)
            end
            b + t
        else
            0f0
        end
    hal = halign2shift(gl.halign[])
    xadjustment = hal * (width(content_bbox) - gridwidth)

    val = 1 - valign2shift(gl.valign[])
    yadjustment = val * (height(content_bbox) - gridheight)

    # compute the x values for all left and right column boundaries
    xleftcols = if alignmode isa Inside
        xadjustment .+ left(content_bbox) .+ zcumsum(colwidths[1:end-1]) .+
            zcumsum(finalcolgaps)
    elseif alignmode isa Outside
        xadjustment .+ left(content_bbox) .+ zcumsum(colwidths[1:end-1]) .+
            zcumsum(finalcolgaps) .+ leftprot
    elseif alignmode isa Mixed
        leftal = getside(alignmode, Left())
        xadjustment .+ left(content_bbox) .+ zcumsum(colwidths[1:end-1]) .+
            zcumsum(finalcolgaps) .+ (isnothing(leftal) ? zero(leftprot) : isa(leftal, Protrusion) ? leftal.p : leftprot)
    else
        error("Unknown AlignMode of type $(typeof(alignmode))")
    end
    xrightcols = xleftcols .+ colwidths

    # compute the y values for all top and bottom row boundaries
    ytoprows = if alignmode isa Inside
        top(content_bbox) .- yadjustment .- zcumsum(rowheights[1:end-1]) .-
            zcumsum(finalrowgaps)
    elseif alignmode isa Outside
        top(content_bbox) .- yadjustment .- zcumsum(rowheights[1:end-1]) .-
            zcumsum(finalrowgaps) .- topprot
    elseif alignmode isa Mixed
        topal = getside(alignmode, Top())
        top(content_bbox) .- yadjustment .- zcumsum(rowheights[1:end-1]) .-
            zcumsum(finalrowgaps) .- (isnothing(topal) ? zero(topprot) : isa(topal, Protrusion) ? topal.p : topprot)
    else
        error("Unknown AlignMode of type $(typeof(alignmode))")
    end
    ybottomrows = ytoprows .- rowheights

    gridboxes = RowCols(
        xleftcols, xrightcols,
        ytoprows, ybottomrows
    )

    maxgrid, gridboxes
end

"""
    tight_bbox(gl::GridLayout)

Compute the boundingbox that would be the fitting `suggestedbbox`
for the current contents of the `GridLayout`. If a `GridLayout` contains
fixed-size content or aspect-constrained columns, for example, it is
likely that the solved size of the `GridLayout` differs from its
`suggestedbbox`. With the result of `tight_bbox` the `suggestedbbox`
can be adjusted (for example by resizing a figure), so that all
content fits the available space. The size includes possible padding, such
as from an `Outside` alignmode on the `GridLayout`.
"""
function tight_bbox(gl::GridLayout)
    maxgrid, gridboxes = compute_rowcols(gl, suggestedbboxobservable(gl)[])
    base_width = gridboxes.rights[end] - gridboxes.lefts[1]
    base_height = gridboxes.tops[1] - gridboxes.bottoms[end]
    al = gl.alignmode[]
    if al isa Outside
        width = base_width + maxgrid.lefts[1] + maxgrid.rights[end] + al.padding.left + al.padding.right
        height = base_height + maxgrid.tops[1] + maxgrid.bottoms[end] + al.padding.top + al.padding.bottom
        l = gridboxes.lefts[1] - maxgrid.lefts[1] - al.padding.left
        b = gridboxes.bottoms[end] - maxgrid.bottoms[end] - al.padding.bottom
        Rect2f((l, b), (width, height))
    elseif al isa Mixed
        error("Mixed not implemented")
    elseif al isa Inside
        l = gridboxes.lefts[1]
        b = gridboxes.bottoms[end]
        Rect2f((l, b), (base_width, base_height))
    else
        error("Invalid alignmode $al")
    end
end

function align_to_bbox!(gl::GridLayout, suggestedbbox::Rect2f)
    # nesting_level(gl) == 2 && error()
    maxgrid, gridboxes = compute_rowcols(gl, suggestedbbox)

    # now we can solve the content thats inside the grid because we know where each
    # column and row is placed, how wide it is, etc.
    # note that what we did at the top was determine the protrusions of all grid content,
    # but we know the protrusions before we know how much space each plot actually has
    # because the protrusions should be static (like tick labels etc don't change size with the plot)

    for c in gl.content
        idx_rect = side_indices(gl, c)
        bbox_cell = mapsides(idx_rect, gridboxes) do side, idx, gridside
            gridside[idx]
        end

        solving_bbox = bbox_for_solving_from_side(maxgrid, bbox_cell, idx_rect, c.side)

        suggestedbboxobservable(c.content)[] = solving_bbox
    end

    nothing
end

dirlength(gl::GridLayout, c::Col) = ncols(gl)
dirlength(gl::GridLayout, r::Row) = nrows(gl)

function dirgaps(gl::GridLayout, dir::GridDir)
    starts = zeros(Float32, dirlength(gl, dir))
    stops = zeros(Float32, dirlength(gl, dir))
    for c in gl.content
        span = getspan(c, dir)
        start = unoffset(gl, span.start, dir)
        stop = unoffset(gl, span.stop, dir)
        starts[start] = max(starts[start], protrusion(c, startside(dir)))
        stops[stop] = max(stops[stop], protrusion(c, stopside(dir)))
    end
    starts, stops
end

dirsizes(gl::GridLayout, c::Col) = gl.colsizes
dirsizes(gl::GridLayout, r::Row) = gl.rowsizes

"""
Determine the size of a grid layout along one of its dimensions.
`Row` measures from bottom to top and `Col` from left to right.
The size is dependent on the alignmode of the grid, `Outside` includes
protrusions and paddings.
"""
function determinedirsize(gl::GridLayout, gdir::GridDir)::Optional{Float32}
    sum_dirsizes = 0f0

    sizes = dirsizes(gl, gdir)

    for idir in 1:dirlength(gl, gdir)
        # width can only be determined for fixed and auto
        sz = sizes[idir]
        idir_offset = offset(gl, idir, gdir)
        dsize = determinedirsize(idir_offset, gl, gdir)

        if isnothing(dsize)
            # early exit if a colsize can not be determined
            return nothing
        end
        sum_dirsizes += dsize
    end

    dirgapsstart, dirgapsstop = dirgaps(gl, gdir)

    forceequalprotrusiongaps = gl.equalprotrusiongaps[gdir isa Row ? 1 : 2]

    dirgapsizes = if forceequalprotrusiongaps
        innergaps = dirgapsstart[2:end] .+ dirgapsstop[1:end-1]
        m = maximum(innergaps)
        innergaps .= m
    else
        innergaps = dirgapsstart[2:end] .+ dirgapsstop[1:end-1]
    end

    inner_gapsizes = dirlength(gl, gdir) > 1 ? sum(dirgapsizes) : 0

    addeddirgapsizes = gdir isa Row ? gl.addedrowgaps : gl.addedcolgaps

    addeddirgaps = dirlength(gl, gdir) == 1 ? 0 : sum(addeddirgapsizes) do c
        if c isa Fixed
            c.x
        elseif c isa Relative
            error("Auto grid size not implemented with relative gaps")
        end
    end

    inner_size_combined = sum_dirsizes + inner_gapsizes + addeddirgaps
    return if gl.alignmode[] isa Inside
        inner_size_combined
    elseif gl.alignmode[] isa Outside
        paddings = if gdir isa Row
            gl.alignmode[].padding.top + gl.alignmode[].padding.bottom
        else
            gl.alignmode[].padding.left + gl.alignmode[].padding.right
        end
        inner_size_combined + dirgapsstart[1] + dirgapsstop[end] + paddings
    else
        error("Unknown AlignMode of type $(typeof(gl.alignmode[]))")
    end
end


"""
Determine the size of one row or column of a grid layout.
`idir` is the dir index including offset (so can be negative)
"""
function determinedirsize(idir::Integer, gl::GridLayout, dir::GridDir)::Optional{Float32}

    sz = dirsizes(gl, dir)[unoffset(gl, idir, dir)]

    if sz isa Fixed
        # fixed dir size can simply be returned
        return sz.x
    elseif sz isa Relative
        # relative dir size can't be inferred
        return nothing
    elseif sz isa Auto
        # auto dir size can either be determined or not, depending on the
        # trydetermine flag
        !sz.trydetermine && return nothing

        dirsize = nothing
        for c in gl.content
            # content has to be single span to be determinable in size
            if dir isa Row
                singlespanned = c.span.rows.start == c.span.rows.stop == idir
            elseif dir isa Col
                singlespanned = c.span.cols.start == c.span.cols.stop == idir
            end

            # content has to be placed with Inner side, otherwise it's protrusion
            # content
            is_inner = c.side isa Inner

            if singlespanned && is_inner
                s = determinedirsize(c, dir, c.side)
                if !isnothing(s)
                    dirsize = isnothing(dirsize) ? s : max(dirsize, s)
                end
            end
        end
        return dirsize
    end
    nothing
end

# a function that iterates over those sizes that belong to a type T
# while enumerating all indices, so that i can be used to index colwidths / rowheights
# and determinedcols / determinedrows
function filterenum(f, T::Type, iter)
    for (i, value) in enumerate(iter)
        value isa T && f((i, value))
    end
    return
end


function compute_col_row_sizes(spaceforcolumns, spaceforrows, gl)::Tuple{Vector{Float32}, Vector{Float32}}
    # the space for columns and for rows is divided depending on the sizes
    # stored in the grid layout

    # algorithm:

    # 1. get fixed sizes
    # 2. compute relative sizes
    # 3. determine determinable auto sizes
    # 4. compute those aspect sizes that are relative to one of the three above categories
    # 5. at least one side now has to have only undeterminable auto sizes left
    # 6. compute remaining auto sizes for one side
    # 7. compute remaining aspect sizes on other side
    # 8. compute remaining auto sizes on the same side

    colwidths = zeros(ncols(gl))
    rowheights = zeros(nrows(gl))

    determinedcols = zeros(Bool, ncols(gl))
    determinedrows = zeros(Bool, nrows(gl))

    # first fixed sizes
    filterenum(Fixed, gl.colsizes) do (i, fixed)
        colwidths[i] = fixed.x
        determinedcols[i] = true
    end
    filterenum(Fixed, gl.rowsizes) do (i, fixed)
        rowheights[i] = fixed.x
        determinedrows[i] = true
    end

    # then relative sizes
    filterenum(Relative, gl.colsizes) do (i, relative)
        colwidths[i] = relative.x * spaceforcolumns
        determinedcols[i] = true
    end
    filterenum(Relative, gl.rowsizes) do (i, relative)
        rowheights[i] = relative.x * spaceforrows
        determinedrows[i] = true
    end

    # then determinable auto sizes
    filterenum(Auto, gl.colsizes) do (i, auto)
        i_offset = offset(gl, i, Col())
        size = determinedirsize(i_offset, gl, Col())
        if !isnothing(size)
            colwidths[i] = size
            determinedcols[i] = true
        end
    end
    filterenum(Auto, gl.rowsizes) do (i, auto)
        i_offset = offset(gl, i, Row())
        size = determinedirsize(i_offset, gl, Row())
        if !isnothing(size)
            rowheights[i] = size
            determinedrows[i] = true
        end
    end

    # now aspect sizes that refer to already determined counterparts
    filterenum(Aspect, gl.colsizes) do (i, aspect)
        aspectindex_unoffset = unoffset(gl, aspect.index, Row())
        if determinedrows[aspectindex_unoffset]
            colwidths[i] = aspect.ratio * rowheights[aspectindex_unoffset]
            determinedcols[i] = true
        end
    end
    filterenum(Aspect, gl.rowsizes) do (i, aspect)
        aspectindex_unoffset = unoffset(gl, aspect.index, Col())
        if determinedcols[aspectindex_unoffset]
            rowheights[i] = aspect.ratio * colwidths[aspectindex_unoffset]
            determinedrows[i] = true
        end
    end

    remaining_colspace = spaceforcolumns - sum(colwidths)
    remaining_rowspace = spaceforrows - sum(rowheights)

    # if we have aspect sizes left on one side, they can only be determined
    # if the other side has only undeterminable autos left
    n_col_aspects_left = sum(enumerate(gl.colsizes)) do (i, size)
        (size isa Aspect) && (determinedcols[i] == false)
    end
    n_row_aspects_left = sum(enumerate(gl.rowsizes)) do (i, size)
        (size isa Aspect) && (determinedrows[i] == false)
    end

    n_col_autos_left = sum(enumerate(gl.colsizes)) do (i, size)
        (size isa Auto) && (determinedcols[i] == false)
    end
    n_row_autos_left = sum(enumerate(gl.rowsizes)) do (i, size)
        (size isa Auto) && (determinedrows[i] == false)
    end

    if n_col_aspects_left == 0
        let
            indices = Int[]
            ratios = Float64[]
            i_ratios = filterenum(Auto, gl.colsizes) do (i, auto)
                if determinedcols[i] == false
                    push!(indices, i)
                    push!(ratios, auto.ratio)
                end
            end
            sumratios = sum(ratios)
            for (i, ratio) in zip(indices, ratios)
                colwidths[i] = ratio / sumratios * remaining_colspace
                determinedcols[i] = true
            end
        end
    end

    if n_row_aspects_left == 0
        let
            indices = Int[]
            ratios = Float64[]
            i_ratios = filterenum(Auto, gl.rowsizes) do (i, auto)
                if determinedrows[i] == false
                    push!(indices, i)
                    push!(ratios, auto.ratio)
                end
            end
            sumratios = sum(ratios)
            for (i, ratio) in zip(indices, ratios)
                rowheights[i] = ratio / sumratios * remaining_rowspace
                determinedrows[i] = true
            end
        end
    end

    # now if either columns or rows had no aspects left, they should have all sizes determined
    # we run over the aspects again
    filterenum(Aspect, gl.colsizes) do (i, aspect)
        aspectindex_unoffset = unoffset(gl, aspect.index, Row())
        if determinedrows[aspectindex_unoffset]
            colwidths[i] = aspect.ratio * rowheights[aspectindex_unoffset]
            determinedcols[i] = true
        else
            error("Column $i was given an Aspect size relative to row $(aspect.index). This row's size could not be determined in time, therefore the layouting algorithm failed. This probably happened because you used an Aspect row and column size at the same time, which couldn't both be resolved.")
        end
    end
    filterenum(Aspect, gl.rowsizes) do (i, aspect)
        aspectindex_unoffset = unoffset(gl, aspect.index, Col())
        if determinedcols[aspectindex_unoffset]
            rowheights[i] = aspect.ratio * colwidths[aspectindex_unoffset]
            determinedrows[i] = true
        else
            error("Row $i was given an Aspect size relative to column $(aspect.index). This column's size could not be determined in time, therefore the layouting algorithm failed. This probably happened because you used an Aspect row and column size at the same time, which couldn't both be resolved.")
        end
    end

    # if we haven't errored yet, all aspect sizes are done
    # one more pass over the undetermined autos is all that's needed

    remaining_colspace = spaceforcolumns - sum(colwidths)
    remaining_rowspace = spaceforrows - sum(rowheights)

    let
        indices = Int[]
        ratios = Float64[]
        i_ratios = filterenum(Auto, gl.colsizes) do (i, auto)
            if determinedcols[i] == false
                push!(indices, i)
                push!(ratios, auto.ratio)
            end
        end
        sumratios = sum(ratios)
        for (i, ratio) in zip(indices, ratios)
            colwidths[i] = ratio / sumratios * remaining_colspace
            determinedcols[i] = true
        end
    end

    let
        indices = Int[]
        ratios = Float64[]
        i_ratios = filterenum(Auto, gl.rowsizes) do (i, auto)
            if determinedrows[i] == false
                push!(indices, i)
                push!(ratios, auto.ratio)
            end
        end
        sumratios = sum(ratios)
        for (i, ratio) in zip(indices, ratios)
            rowheights[i] = ratio / sumratios * remaining_rowspace
            determinedrows[i] = true
        end
    end


    # now all columns and rows should have their sizes
    ncols_undetermined = sum(.!determinedcols)
    nrows_undetermined = sum(.!determinedrows)

    if ncols_undetermined > 0
        error("After a non-erroring layouting pass, the number of undetermined columns is $ncols_undetermined. This must be a bug.")
    end
    if nrows_undetermined > 0
        error("After a non-erroring layouting pass, the number of undetermined rows is $nrows_undetermined. This must be a bug.")
    end

    colwidths, rowheights
end

function Base.setindex!(g::GridLayout, content, rows::Indexables, cols::Indexables, side::Side = Inner())
    add_content!(g, content, rows, cols, side)
    content
end

function Base.setindex!(g::GridLayout, content_array::AbstractArray{T, 2}) where T
    rowrange = 1:size(content_array, 1)
    colrange = 1:size(content_array, 2)
    g[rowrange, colrange] = content_array
end

function Base.setindex!(g::GridLayout, content_array::AbstractArray{T, 1}) where T
    error("""
        You can only assign a one-dimensional content AbstractArray if you also specify the direction in the layout.
        Valid options are :h for horizontal and :v for vertical.
        Example:
            layout[:h] = contentvector
    """)
end

function Base.setindex!(g::GridLayout, content_array::AbstractArray{T, 1}, h_or_v::Symbol) where T
    if h_or_v == :h
        g[1, 1:length(content_array)] = content_array
    elseif h_or_v == :v
        g[1:length(content_array), 1] = content_array
    else
        error("""
            Invalid direction specifier $h_or_v.
            Valid options are :h for horizontal and :v for vertical.
        """)
    end
end

function Base.setindex!(g::GridLayout, content_array::AbstractArray, rows::Indexables, cols::Indexables)

    rows, cols = to_ranges(g, rows, cols)

    if rows.start < 1
        error("Can't prepend rows using array syntax so far, start row $(rows.start) is smaller than 1.")
    end
    if cols.start < 1
        error("Can't prepend columns using array syntax so far, start column $(cols.start) is smaller than 1.")
    end

    nrows = length(rows)
    ncols = length(cols)
    ncells = nrows * ncols

    if ndims(content_array) == 2
        if size(content_array) != (nrows, ncols)
            error("Content array size is size $(size(content_array)) for $nrows rows and $ncols cols")
        end
        # put the array content into the grid layout in order
        for (i, r) in enumerate(rows), (j, c) in enumerate(cols)
            g[r, c] = content_array[i, j]
        end
    elseif ndims(content_array) == 1
        if length(content_array) != nrows * ncols
            error("Content array size is length $(length(content_array)) for $nrows * $ncols cells")
        end
        # put the content in the layout along columns first, because that is more
        # intuitive
        for (i, (c, r)) in enumerate(Iterators.product(cols, rows))
            g[r, c] = content_array[i]
        end
    else
        error("Can't assign a content array with $(ndims(content_array)) dimensions, only 1 or 2.")
    end
    content_array
end

function GridContent(content, span::Span, side::Side)
    # connect the correct observables
    gc = GridContent{GridLayout}(nothing, content, span, side, nothing, nothing)
    connect_layoutobservables!(gc)
    gc
end

function update!(gc::GridContent)
    p = gc.parent
    if p isa GridLayout
        update!(p)
    end
    return
end

function add_content!(g::GridLayout, content, rows, cols, side::Side)
    # update = false because update is called in add_to_gridlayout! anyway
    rows, cols = adjust_rows_cols!(g, rows, cols; update = false)

    gc = if !isnothing(gridcontent(content))
        # take the existing gridcontent, remove it from its gridlayout if it has one,
        # and modify it with the new span and side
        gridc = gridcontent(content)
        remove_from_gridlayout!(gridc)
        gridc.span = Span(rows, cols)
        gridc.side = side
        gridc
    else
        # make a new one if none existed
        GridContent(content, Span(rows, cols), side)
    end

    layoutobservables(content).gridcontent[] = gc

    connect_layoutobservables!(gc)

    add_to_gridlayout!(g, gc)
end

function Base.lastindex(g::GridLayout, d)
    if d == 1
        lastrow(g)
    elseif d == 2
        lastcol(g)
    else
        error("A grid only has two dimensions, you're indexing dimension $d.")
    end
end

function Base.firstindex(g::GridLayout, d)
    if d == 1
        firstrow(g)
    elseif d == 2
        firstcol(g)
    else
        error("A grid only has two dimensions, you're indexing dimension $d.")
    end
end

function GridPosition(g::GridLayout, rows::Indexables, cols::Indexables, side = Inner())
    span = Span(to_ranges(g, rows, cols)...)
    GridPosition(g, span, side)
end

function Base.getindex(g::GridLayout, rows::Indexables, cols::Indexables, side = Inner())
    GridPosition(g, rows, cols, side)
end

function Base.setindex!(gp::GridPosition, element)
    gp.layout[gp.span.rows, gp.span.cols, gp.side] = element
end

function Base.setindex!(gp::GridPosition, element, rows, cols, side = Inner())
    layout = get_layout_at!(gp, createmissing = true)
    layout[rows, cols, side] = element
    element
end

"""
    nrows(g::GridLayout)

Return the number of rows in `g`.
"""
nrows(g::GridLayout) = size(g)[1]
"""
    ncols(g::GridLayout)

Return the number of columns in `g`.
"""
ncols(g::GridLayout) = size(g)[2]
Base.size(g::GridLayout) = g.size
offsets(g::GridLayout) = g.offsets

Base.in(span1::Span, span2::Span) = span1.rows.start >= span2.rows.start &&
    span1.rows.stop <= span2.rows.stop &&
    span1.cols.start >= span2.cols.start &&
    span1.cols.stop <= span2.cols.stop

"""
    contents(gp::GridPosition; exact::Bool = false)

Retrieve all objects placed in the `GridLayout` at the `Span` and `Side` stored
in the `GridPosition` `gp`. If `exact == true`, elements are only included
if they match the `Span` exactly, otherwise they can also be contained within the spanned layout area.
"""
function contents(gp::GridPosition; exact::Bool = false)
    contents = []
    for c in gp.layout.content
        if exact
            if c.span == gp.span && c.side == gp.side
                push!(contents, c.content)
            end
        else
            if c.span in gp.span && c.side == gp.side
                push!(contents, c.content)
            end
        end
    end
    contents
end

"""
    contents(g::GridLayout)

Retrieve all objects placed in the `GridLayout` `g`, in the order they are stored, extracted from
their containing `GridContent`s.
"""
function contents(g::GridLayout)
    map(g.content) do gc
        gc.content
    end
end


function Base.getindex(gp::Union{GridPosition, GridSubposition}, rows, cols, side = Inner())
    GridSubposition(gp, rows, cols, side)
end

function Base.setindex!(parent::GridSubposition, obj,
    rows, cols, side = GridLayoutBase.Inner())
    layout = get_layout_at!(parent, createmissing = true)
    layout[rows, cols, side] = obj
    obj
end

function Base.setindex!(parent::GridSubposition, obj)
    layout = get_layout_at!(parent.parent, createmissing = true)
    layout[parent.rows, parent.cols, parent.side] = obj
    obj
end

function get_layout_at!(gp::GridPosition; createmissing = false)
    c = contents(gp, exact = true)
    layouts = filter(x -> x isa GridLayoutBase.GridLayout, c)
    if isempty(layouts)
        if createmissing
            return gp[] = GridLayoutBase.GridLayout()
        else
            error("No layout found but `createmissing` is false.")
        end
    elseif length(layouts) == 1
        return first(layouts)
    else
        error("Found more than zero or one GridLayouts at $gp")
    end
end

function get_layout_at!(gsp::GridSubposition; createmissing = false)
    layout = get_layout_at!(gsp.parent; createmissing = createmissing)
    gp = layout[gsp.rows, gsp.cols, gsp.side]
    get_layout_at!(gp, createmissing = createmissing)
end


function contents(g::GridSubposition; exact = false)
    layout = get_layout_at!(g.parent, createmissing = false)
    contents(layout[g.rows, g.cols, g.side], exact = exact)
end

"""
    content(g::Union{GridPosition,GridSubposition})

Return the one object placed in the `GridLayout` at the `Span` and `Side`
stored in the `GridPosition` `g`. If there is more than one object at that
position, throw an error.

See also `contents`.
"""
function content(g::Union{GridPosition,GridSubposition})
    cs = contents(g, exact = true)
    if length(cs) == 1
        return cs[1]
    else
        error("There is not exactly one object at the given GridPosition")
    end
end


function parent(g::GridLayout)
    g.parent
end

function top_parent(g::GridLayout)
    top_parent(parent(g))
end

top_parent(x) = x

function top_parent_grid(g::GridLayout)
    p = parent(g)
    if p isa GridLayout
        top_parent_grid(p)
    else
        g
    end
end

"""
    side_indices(gl::GridLayout, c::GridContent)::RowCols{Int}

Indices of the rows / cols for each side
"""
function side_indices(gl, c::GridContent)
    return RowCols(
        c.span.cols.start - offset(gl, Col()),
        c.span.cols.stop - offset(gl, Col()),
        c.span.rows.start - offset(gl, Row()),
        c.span.rows.stop - offset(gl, Row()),
    )
end

# These functions tell whether an object in a grid touches the left, top, etc. border
# of the grid. This means that it is relevant for the grid's own protrusion on that side.
ismostin(gc::GridContent, grid, ::Left) = gc.span.cols.start == firstcol(grid)
ismostin(gc::GridContent, grid, ::Right) = gc.span.cols.stop == lastcol(grid)
ismostin(gc::GridContent, grid, ::Bottom) = gc.span.rows.stop == lastrow(grid)
ismostin(gc::GridContent, grid, ::Top) = gc.span.rows.start == firstrow(grid)


function protrusion(x::T, side::Side) where T
    protrusions = protrusionsobservable(x)[]::RectSides{Float32}
    if side isa Left
        protrusions.left
    elseif side isa Right
        protrusions.right
    elseif side isa Bottom
        protrusions.bottom
    elseif side isa Top
        protrusions.top
    else
        error("Can't get a protrusion value for side $(typeof(side)), only
        Left, Right, Bottom, or Top.")
    end
end

function protrusion(gc::GridContent, side::Side)
    prot =
        if gc.side isa Inner
            protrusion(gc.content, side)
        elseif gc.side isa Outer
            0.0
        elseif gc.side isa Union{Left, Right}
            if side isa typeof(gc.side)
                determinedirsize(gc.content, Col(), gc.side)
            else
                0.0
            end
        elseif gc.side isa Union{Top, Bottom}
            if side isa typeof(gc.side)
                determinedirsize(gc.content, Row(), gc.side)
            else
                0.0
            end
        elseif gc.side isa TopLeft
            if side isa Top
                determinedirsize(gc.content, Row(), gc.side)
            elseif side isa Left
                determinedirsize(gc.content, Col(), gc.side)
            else
                0.0
            end
        elseif gc.side isa TopRight
            if side isa Top
                determinedirsize(gc.content, Row(), gc.side)
            elseif side isa Right
                determinedirsize(gc.content, Col(), gc.side)
            else
                0.0
            end
        elseif gc.side isa BottomLeft
            if side isa Bottom
                determinedirsize(gc.content, Row(), gc.side)
            elseif side isa Left
                determinedirsize(gc.content, Col(), gc.side)
            else
                0.0
            end
        elseif gc.side isa BottomRight
            if side isa Bottom
                determinedirsize(gc.content, Row(), gc.side)
            elseif side isa Right
                determinedirsize(gc.content, Col(), gc.side)
            else
                0.0
            end
        else
            error("Invalid side $(gc.side)")
        end
    ifnothing(prot, 0.0)
end

getside(m::Mixed, ::Left) = m.sides.left
getside(m::Mixed, ::Right) = m.sides.right
getside(m::Mixed, ::Top) = m.sides.top
getside(m::Mixed, ::Bottom) = m.sides.bottom

function compute_effective_protrusion(gl::GridLayout, side::Side)
    al = gl.alignmode[]
    if al isa Outside
        return 0f0
    elseif al isa Inside
        compute_effective_protrusion_inside(gl, side)
    elseif al isa Mixed
        si = getside(al, side)
        if isnothing(si)
            compute_effective_protrusion_inside(gl, side)
        elseif si isa Protrusion
            si.p
        else
            # Outside alignment
            0f0
        end
    else
        error("Unknown AlignMode of type $(typeof(al))")
    end
end

function compute_effective_protrusion_inside(gl::GridLayout, side::Side)
    prot = 0f0
    for elem in gl.content
        if ismostin(elem, gl, side)
            # take the max protrusion of all elements that are sticking
            # out at this side
            prot = max(effective_protrusion(elem, side, elem.side), prot)
        end
    end
    return prot
end

function inside_protrusion(gl::GridLayout, side::Side)
    prot = 0.0
    for elem in gl.content
        if ismostin(elem, gl, side)
            # take the max protrusion of all elements that are sticking
            # out at this side
            prot = max(protrusion(elem, side), prot)
        end
    end
    return prot
end

function protrusion(gl::GridLayout, side::Side)::Float32
    # when we align with the outside there is by definition no protrusion

    al = gl.alignmode[]
    if al isa Outside
        return 0f0
    elseif al isa Inside
        inside_protrusion(gl, side)
    elseif al isa Mixed
        si = getside(al, side)
        if isnothing(si)
            inside_protrusion(gl, side)
        elseif si isa Protrusion
            si.p
        else
            # Outside alignment
            0f0
        end
    else
        error("Unknown AlignMode of type $(typeof(al))")
    end
end

function bbox_for_solving_from_side(maxgrid::RowCols, bbox_cell::Rect2f, idx_rect::RowCols, side::Side)
    pl = maxgrid.lefts[idx_rect.lefts]
    pr = maxgrid.rights[idx_rect.rights]
    pt = maxgrid.tops[idx_rect.tops]
    pb = maxgrid.bottoms[idx_rect.bottoms]

    l = left(bbox_cell)
    r = right(bbox_cell)
    b = bottom(bbox_cell)
    t = top(bbox_cell)

    if side isa Inner
        bbox_cell
    elseif side isa Outer
        BBox(l - pl, r + pr, b - pb, t + pt)
    elseif side isa Left
        BBox(l - pl, l, b, t)
    elseif side isa Top
        BBox(l, r, t, t + pt)
    elseif side isa Right
        BBox(r, r + pr, b, t)
    elseif side isa Bottom
        BBox(l, r, b - pb, b)
    elseif side isa TopLeft
        BBox(l - pl, l, t, t + pt)
    elseif side isa TopRight
        BBox(r, r + pr, t, t + pt)
    elseif side isa BottomRight
        BBox(r, r + pr, b - pb, b)
    elseif side isa BottomLeft
        BBox(l - pl, l, b - pb, b)
    else
        error("Invalid side $side")
    end
end

startside(c::Col) = Left()
stopside(c::Col) = Right()
startside(r::Row) = Top()
stopside(r::Row) = Bottom()


getspan(gc::GridContent, dir::Col) = gc.span.cols
getspan(gc::GridContent, dir::Row) = gc.span.rows



"""
Determine the size of a protrusion layout along a dimension. This size is dependent
on the `Side` at which the layout is placed in its parent grid. An `Inside` side
means that the protrusion layout reports its width but not its protrusions. `Left`
means that the layout reports only its full width but not its height, because
an element placed in the left protrusion loses its ability to influence height.
"""
function determinedirsize(content, gdir::GridDir, side::Side)
    reportedsize = reporteddimensionsobservable(content)[].inner
    if gdir isa Row
        if side isa Union{Inner, Top, Bottom, TopLeft, TopRight, BottomLeft, BottomRight}
            # TODO: is reportedsize the correct thing to return? or plus protrusions depending on the side
            ifnothing(reportedsize[2], nothing)
        elseif side isa Union{Left, Right}
            nothing
        else
            error("$side not implemented")
        end
    else
        if side isa Union{Inner, Left, Right, TopLeft, TopRight, BottomLeft, BottomRight}
            ifnothing(reportedsize[1], nothing)
        elseif side isa Union{Top, Bottom}
            nothing
        else
            error("$side not implemented")
        end
    end
end

determinedirsize(gc::GridContent, gdir::GridDir, side::Side) = determinedirsize(gc.content, gdir, side)::Optional{Float32}

function to_ranges(g::GridLayout, rows::Indexables, cols::Indexables)
    if rows isa Int
        rows = rows:rows
    elseif rows isa Colon
        rows = firstrow(g):lastrow(g)
    end
    if cols isa Int
        cols = cols:cols
    elseif cols isa Colon
        cols = firstcol(g):lastcol(g)
    end
    rows, cols
end

function adjust_rows_cols!(g::GridLayout, rows, cols; update = true)
    rows, cols = to_ranges(g, rows, cols)

    rowdiff_start = firstrow(g) - rows.start
    if rowdiff_start > 0
        prependrows!(g, rowdiff_start, update = update)
    end
    rowdiff_stop = rows.stop - lastrow(g)
    if rowdiff_stop > 0
        appendrows!(g, rowdiff_stop, update = update)
    end
    coldiff_start = firstcol(g) - cols.start
    if coldiff_start > 0
        prependcols!(g, coldiff_start, update = update)
    end
    coldiff_stop = cols.stop - lastcol(g)

    if coldiff_stop > 0
        appendcols!(g, coldiff_stop, update = update)
    end

    rows, cols
end

firstrow(g) = (1 + offsets(g)[1])
firstcol(g) = (1 + offsets(g)[2])
lastrow(g) = (nrows(g) + offsets(g)[1])
lastcol(g) = (ncols(g) + offsets(g)[2])

module GridLayoutBase

using GeometryBasics
using Observables
import GeometryBasics: height, width

const DEFAULT_COLGAP = Ref{Float64}(20.0)
const DEFAULT_ROWGAP = Ref{Float64}(20.0)
# These function refs can be mutated by other packages to override the default
# way of retrieving default column and row gap sizes
const DEFAULT_ROWGAP_GETTER = Ref{Function}(() -> DEFAULT_ROWGAP[])
const DEFAULT_COLGAP_GETTER = Ref{Function}(() -> DEFAULT_COLGAP[])

include("types.jl")
include("gridlayout.jl")
include("layoutobservables.jl")
include("helpers.jl")

export GridLayout, GridPosition
export BBox
export LayoutObservables
export Inside, Outside, Mixed, Protrusion
export Fixed, Auto, Relative, Aspect
export width, height, top, bottom, left, right
export with_updates_suspended
export appendcols!, appendrows!, prependcols!, prependrows!, deletecol!, deleterow!, trim!, insertrows!, insertcols!
export gridnest!
export AxisAspect, DataAspect
export colsize!, rowsize!, colgap!, rowgap!
export Left, Right, Top, Bottom, TopLeft, BottomLeft, TopRight, BottomRight
export grid!, hbox!, vbox!
export swap!
export protrusionsobservable, suggestedbboxobservable, reporteddimensionsobservable, autosizeobservable, computedbboxobservable, gridcontent
export ncols, nrows, offsets
export contents, content
export tight_bbox

if Base.VERSION >= v"1.4.2"
    include("precompile.jl")
end

end
